/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse fepparse
#define yylex   feplex
#define yyerror feperror
#define yylval  feplval
#define yychar  fepchar
#define yydebug fepdebug
#define yynerrs fepnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_BINARY_XOR_ASSIGN = 258,
     T_BINARY_OR_ASSIGN = 259,
     T_BINARY_AND_ASSIGN = 260,
     T_RIGHT_SHIFT_ASSIGN = 261,
     T_LEFT_SHIFT_ASSIGN = 262,
     T_DIVIDE_ASSIGN = 263,
     T_MULT_ASSIGN = 264,
     T_MINUS_ASSIGN = 265,
     T_PLUS_ASSIGN = 266,
     T_ASSIGN = 267,
     T_LOGICAL_OR = 268,
     T_RARROW = 269,
     T_LOGICAL_AND = 270,
     T_BINARY_OR = 271,
     T_BINARY_AND = 272,
     T_BINARY_XOR = 273,
     T_NOTEQUAL = 274,
     T_GRTRTHAN = 275,
     T_LESSTHAN = 276,
     T_GRTRTHAN_EQUALS = 277,
     T_LESSTHAN_EQUALS = 278,
     T_EQUALS = 279,
     T_INSTANCEOF = 280,
     T_ISA = 281,
     T_RIGHT_SHIFT = 282,
     T_LEFT_SHIFT = 283,
     T_MINUS = 284,
     T_PLUS = 285,
     T_MODULUS = 286,
     T_DIVIDE = 287,
     T_MULT = 288,
     T_NOT_OPERATOR = 289,
     T_DECR = 290,
     T_INCR = 291,
     T_UPLUS = 292,
     T_UMINUS = 293,
     T_OBJOP = 294,
     T_NEW = 295,
     T_IF = 296,
     T_ELSE = 297,
     T_INCLUDE = 298,
     T_EVAL = 299,
     T_FUNCTION = 300,
     T_FOR = 301,
     T_WHILE = 302,
     T_DO = 303,
     T_SWITCH = 304,
     T_IFERR = 305,
     T_FIX = 306,
     T_CASE = 307,
     T_DEFAULT = 308,
     T_USES = 309,
     T_GLOBAL = 310,
     T_RETURN = 311,
     T_FINAL = 312,
     T_NAMESPACE = 313,
     T_CLASS = 314,
     T_EXTENDS = 315,
     T_BREAK = 316,
     T_CONTINUE = 317,
     T_STATIC = 318,
     T_MULTIPLE_ARGS = 319,
     T_MODIFIES = 320,
     T_RENAME = 321,
     T_ALIAS = 322,
     T_NATIVE = 323,
     T_MODULE_INIT = 324,
     T_MODULE_DEINIT = 325,
     T_MODULE_HEADER = 326,
     T_MODULE_FLAGS = 327,
     T_SLICE = 328,
     T_ATOMIC = 329,
     T_ERROR = 330,
     T_MODULE_REGISTER = 331,
     T_MODULE_UNREGISTER = 332,
     T_FOREACH = 333,
     T_ARGS = 334,
     T_PRIVATE = 335,
     T_PROTECTED = 336,
     T_PUBLIC = 337,
     T_ABSTRACT = 338,
     T_CLOSURE = 339,
     T_USING = 340,
     T_DELIVER = 341,
     T_RECIPIENT = 342,
     T_PROTOCOL = 343,
     T_IMPLEMENTS = 344,
     T_SELF = 345,
     T_SUPER = 346,
     T_CONSTRUCTOR = 347,
     T_DESTRUCTOR = 348,
     T_VAR_NUMBER = 349,
     T_VAR_STRING = 350,
     T_VAR_VOID = 351,
     T_VAR_OBJECT = 352,
     T_VAR_ARRAY = 353,
     T_QSTRING = 354,
     T_VARTYPE = 355,
     T_LABEL = 356,
     T_OBJPROPERTY = 357,
     T_NATIVE_CODE_BLOCK = 358,
     T_DOT_LABEL = 359,
     T_NNUMBER = 360,
     T_TRUE = 361,
     T_FALSE = 362,
     T_RNUMBER = 363
   };
#endif
#define T_BINARY_XOR_ASSIGN 258
#define T_BINARY_OR_ASSIGN 259
#define T_BINARY_AND_ASSIGN 260
#define T_RIGHT_SHIFT_ASSIGN 261
#define T_LEFT_SHIFT_ASSIGN 262
#define T_DIVIDE_ASSIGN 263
#define T_MULT_ASSIGN 264
#define T_MINUS_ASSIGN 265
#define T_PLUS_ASSIGN 266
#define T_ASSIGN 267
#define T_LOGICAL_OR 268
#define T_RARROW 269
#define T_LOGICAL_AND 270
#define T_BINARY_OR 271
#define T_BINARY_AND 272
#define T_BINARY_XOR 273
#define T_NOTEQUAL 274
#define T_GRTRTHAN 275
#define T_LESSTHAN 276
#define T_GRTRTHAN_EQUALS 277
#define T_LESSTHAN_EQUALS 278
#define T_EQUALS 279
#define T_INSTANCEOF 280
#define T_ISA 281
#define T_RIGHT_SHIFT 282
#define T_LEFT_SHIFT 283
#define T_MINUS 284
#define T_PLUS 285
#define T_MODULUS 286
#define T_DIVIDE 287
#define T_MULT 288
#define T_NOT_OPERATOR 289
#define T_DECR 290
#define T_INCR 291
#define T_UPLUS 292
#define T_UMINUS 293
#define T_OBJOP 294
#define T_NEW 295
#define T_IF 296
#define T_ELSE 297
#define T_INCLUDE 298
#define T_EVAL 299
#define T_FUNCTION 300
#define T_FOR 301
#define T_WHILE 302
#define T_DO 303
#define T_SWITCH 304
#define T_IFERR 305
#define T_FIX 306
#define T_CASE 307
#define T_DEFAULT 308
#define T_USES 309
#define T_GLOBAL 310
#define T_RETURN 311
#define T_FINAL 312
#define T_NAMESPACE 313
#define T_CLASS 314
#define T_EXTENDS 315
#define T_BREAK 316
#define T_CONTINUE 317
#define T_STATIC 318
#define T_MULTIPLE_ARGS 319
#define T_MODIFIES 320
#define T_RENAME 321
#define T_ALIAS 322
#define T_NATIVE 323
#define T_MODULE_INIT 324
#define T_MODULE_DEINIT 325
#define T_MODULE_HEADER 326
#define T_MODULE_FLAGS 327
#define T_SLICE 328
#define T_ATOMIC 329
#define T_ERROR 330
#define T_MODULE_REGISTER 331
#define T_MODULE_UNREGISTER 332
#define T_FOREACH 333
#define T_ARGS 334
#define T_PRIVATE 335
#define T_PROTECTED 336
#define T_PUBLIC 337
#define T_ABSTRACT 338
#define T_CLOSURE 339
#define T_USING 340
#define T_DELIVER 341
#define T_RECIPIENT 342
#define T_PROTOCOL 343
#define T_IMPLEMENTS 344
#define T_SELF 345
#define T_SUPER 346
#define T_CONSTRUCTOR 347
#define T_DESTRUCTOR 348
#define T_VAR_NUMBER 349
#define T_VAR_STRING 350
#define T_VAR_VOID 351
#define T_VAR_OBJECT 352
#define T_VAR_ARRAY 353
#define T_QSTRING 354
#define T_VARTYPE 355
#define T_LABEL 356
#define T_OBJPROPERTY 357
#define T_NATIVE_CODE_BLOCK 358
#define T_DOT_LABEL 359
#define T_NNUMBER 360
#define T_TRUE 361
#define T_FALSE 362
#define T_RNUMBER 363




/* Copy the first part of user declarations.  */
#line 1 "ferite_parser.y"

/*
 * Copyright (C) 2000-2005 Chris Ross and various contributors
 * Copyright (C) 1999-2000 Chris Ross
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 * o Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * o Neither the name of the ferite software nor the names of its contributors may
 *   be used to endorse or promote products derived from this software without
 *   specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 *  This is the parser for the ferite programming language
 *  Written by Chris Ross (chris@ferite.org)
 */

#include "ferite.h"
#include "ferite/fcompile.h"
#include "ferite/foop.h" 
#include <string.h>
#include <setjmp.h>

#ifdef WIN32
# include "snprintf.h" /* This is so that we have somethings */
#endif

#define YYERROR_VERBOSE

extern jmp_buf  ferite_compiler_jmpback;
extern int      ferite_scanner_lineno;
extern char    *ferite_scanner_file;
extern int      ferite_compile_error;
extern char    *ferite_last_token_alloc;
extern FeriteCompileRecord *ferite_current_compile;

extern FeriteStack *ferite_compiled_arrays_stack;
extern FeriteStack *ferite_argcount_stack;

char           *ferite_last_function;
int             ferite_last_type;
FeriteVariable *ferite_temp_variable;
char            ferite_fetypebuf[1024];
char            ferite_fenamebuf[1024];
int             ferite_var_is_global = FE_FALSE;
int             ferite_var_is_params = FE_FALSE;
int             ferite_var_is_final = FE_FALSE;
int             ferite_var_is_static = FE_FALSE;
int             ferite_var_is_atomic = FE_FALSE;
int             ferite_var_is_native = FE_FALSE;
int             ferite_var_pass_type = FE_BY_VALUE;
int             ferite_item_state = FE_ITEM_IS_PRIVATE;
int             ferite_class_state = 0;
int             ferite_current_arg_count = 0;
int             ferite_var_array_count = 0;
int             ferite_namespace_naturaln = 0;

void feperror( char *message );
int  feplex();
void ferite_scanner_go_native();

#define FECT    ferite_last_token_alloc = NULL
   
   /***
  * Native Code Support
  ***/
   extern char ferite_current_native_block_file[4096];
   extern int  ferite_current_native_block_line;
   


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 91 "ferite_parser.y"
typedef union YYSTYPE {
  char   *text;
  int     inumber;
  double  fnumber;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 396 "ferite_parser.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 408 "ferite_parser.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  52
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1404

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  119
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  161
/* YYNRULES -- Number of rules. */
#define YYNRULES  340
/* YYNRULES -- Number of states. */
#define YYNSTATES  545

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   363

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     113,   114,     2,     2,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   115,   110,
       2,     2,     2,   118,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   116,     2,   117,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   111,     2,   112,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     9,    10,    12,    14,    17,    19,
      21,    23,    25,    27,    29,    32,    34,    35,    39,    40,
      44,    45,    49,    50,    54,    55,    59,    60,    64,    68,
      70,    72,    76,    77,    83,    85,    87,    89,    91,    93,
      95,    97,    99,   101,   103,   105,   108,   112,   117,   119,
     121,   122,   127,   128,   130,   135,   137,   138,   140,   144,
     146,   148,   152,   155,   159,   160,   162,   164,   167,   172,
     176,   179,   181,   183,   185,   187,   192,   193,   195,   197,
     200,   201,   204,   208,   211,   216,   221,   223,   224,   229,
     230,   234,   235,   238,   240,   244,   245,   248,   254,   259,
     263,   265,   267,   270,   273,   275,   278,   279,   281,   282,
     285,   290,   292,   293,   298,   301,   304,   306,   308,   312,
     316,   320,   322,   326,   328,   332,   334,   336,   337,   339,
     341,   343,   345,   347,   349,   351,   353,   354,   356,   358,
     361,   363,   364,   367,   371,   373,   374,   376,   378,   380,
     382,   383,   387,   388,   394,   395,   400,   401,   403,   407,
     412,   413,   419,   421,   423,   425,   426,   428,   430,   432,
     434,   437,   440,   442,   444,   447,   450,   453,   455,   457,
     460,   461,   469,   470,   471,   479,   481,   482,   483,   487,
     488,   497,   500,   501,   503,   505,   508,   509,   515,   516,
     517,   522,   523,   524,   528,   529,   531,   533,   535,   537,
     538,   539,   540,   541,   542,   543,   559,   560,   561,   569,
     570,   579,   581,   583,   585,   587,   589,   591,   593,   595,
     597,   599,   601,   603,   610,   611,   618,   624,   629,   634,
     638,   641,   644,   645,   648,   650,   653,   655,   658,   660,
     663,   666,   668,   675,   677,   679,   683,   684,   688,   689,
     690,   695,   698,   702,   706,   710,   714,   718,   722,   726,
     730,   734,   738,   742,   746,   750,   754,   758,   762,   766,
     770,   774,   778,   782,   786,   790,   794,   798,   802,   808,
     811,   814,   817,   820,   823,   826,   829,   834,   839,   843,
     847,   851,   855,   857,   859,   861,   863,   865,   869,   874,
     875,   876,   886,   887,   890,   895,   901,   902,   909,   910,
     917,   922,   923,   924,   927,   929,   933,   934,   937,   938,
     943,   944,   946,   948,   952,   955,   956,   959,   960,   965,
     966
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     120,     0,    -1,    -1,   122,   121,   191,   206,    -1,    -1,
     123,    -1,   124,    -1,   123,   124,    -1,   132,    -1,   135,
      -1,   179,    -1,   171,    -1,   155,    -1,   125,    -1,   189,
     143,    -1,   153,    -1,    -1,    70,   126,   104,    -1,    -1,
      71,   127,   104,    -1,    -1,    77,   128,   104,    -1,    -1,
      78,   129,   104,    -1,    -1,    72,   130,   104,    -1,    -1,
      73,   131,   104,    -1,    55,   134,   110,    -1,   100,    -1,
     133,    -1,   134,     3,   133,    -1,    -1,    56,   136,   111,
     200,   112,    -1,    95,    -1,    96,    -1,    97,    -1,    98,
      -1,    99,    -1,   137,    -1,    60,    -1,    59,    -1,   102,
      -1,    93,    -1,    94,    -1,    46,   139,    -1,   113,   148,
     114,    -1,   111,   191,   206,   112,    -1,   104,    -1,   209,
      -1,    -1,   140,   141,   144,   142,    -1,    -1,    18,    -1,
     138,   195,   145,   102,    -1,    65,    -1,    -1,   149,    -1,
     149,     3,   147,    -1,   147,    -1,   146,    -1,   149,     3,
     146,    -1,    59,   102,    -1,    59,    66,   102,    -1,    -1,
     152,    -1,   154,    -1,   152,   154,    -1,    67,   102,   102,
     110,    -1,   189,   198,   110,    -1,   189,   143,    -1,   179,
      -1,   171,    -1,   155,    -1,   153,    -1,   150,   111,   151,
     112,    -1,    -1,   157,    -1,   158,    -1,   157,   158,    -1,
      -1,   159,   160,    -1,   189,   198,   110,    -1,   189,   143,
      -1,    67,   102,   102,   110,    -1,    68,   102,   102,   110,
      -1,   102,    -1,    -1,   102,    61,   162,   105,    -1,    -1,
      66,   164,   105,    -1,    -1,   166,   105,    -1,   165,    -1,
     167,     3,   165,    -1,    -1,    90,   167,    -1,   161,   168,
     111,   156,   112,    -1,   163,   111,   156,   112,    -1,   187,
      60,   172,    -1,   169,    -1,   170,    -1,    89,   102,    -1,
     189,   143,    -1,   174,    -1,   175,   174,    -1,    -1,   175,
      -1,    -1,   178,   176,    -1,   173,   111,   177,   112,    -1,
     102,    -1,    -1,   102,    13,   181,   241,    -1,    30,   106,
      -1,    31,   106,    -1,   106,    -1,   102,    -1,   102,    13,
     182,    -1,   102,    13,   109,    -1,   102,    13,   100,    -1,
     180,    -1,   184,     3,   180,    -1,   183,    -1,   185,     3,
     183,    -1,    58,    -1,    84,    -1,    -1,   186,    -1,    58,
      -1,    64,    -1,    75,    -1,    69,    -1,    81,    -1,    82,
      -1,    83,    -1,    -1,   190,    -1,   188,    -1,   190,   188,
      -1,   192,    -1,    -1,   196,   110,    -1,   192,   196,   110,
      -1,    58,    -1,    -1,   102,    -1,   100,    -1,   109,    -1,
     106,    -1,    -1,    22,   194,    21,    -1,    -1,   193,   137,
     197,   195,   184,    -1,    -1,   137,   199,   195,   185,    -1,
      -1,   201,    -1,   189,   198,   110,    -1,   201,   189,   198,
     110,    -1,    -1,   111,   203,   191,   206,   112,    -1,   209,
      -1,   202,    -1,   206,    -1,    -1,   208,    -1,   209,    -1,
     202,    -1,   207,    -1,   208,   207,    -1,   241,   110,    -1,
     211,    -1,   231,    -1,   210,   110,    -1,    62,   110,    -1,
      63,   110,    -1,   110,    -1,    57,    -1,    57,   241,    -1,
      -1,    42,   113,   241,   114,   212,   204,   215,    -1,    -1,
      -1,    51,   213,   204,   214,    52,   204,   226,    -1,   217,
      -1,    -1,    -1,    43,   216,   204,    -1,    -1,    50,   218,
     113,   241,   114,   111,   219,   112,    -1,   220,   224,    -1,
      -1,   221,    -1,   222,    -1,   221,   222,    -1,    -1,    53,
     241,   223,   115,   205,    -1,    -1,    -1,    54,   115,   225,
     206,    -1,    -1,    -1,    43,   227,   204,    -1,    -1,   241,
      -1,   228,    -1,   196,    -1,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,   113,   232,   229,   233,   110,   234,
     228,   235,   110,   236,   228,   237,   114,   204,    -1,    -1,
      -1,    48,   238,   113,   241,   114,   239,   204,    -1,    -1,
      49,   240,   204,    48,   113,   241,   114,   110,    -1,   230,
      -1,   243,    -1,   242,    -1,   258,    -1,   100,    -1,   107,
      -1,   108,    -1,   106,    -1,   109,    -1,   102,    -1,    91,
      -1,    92,    -1,   243,   116,   241,    74,   241,   117,    -1,
      -1,   243,   116,    74,   244,   241,   117,    -1,   243,   116,
     241,    74,   117,    -1,   243,   116,    74,   117,    -1,   243,
     116,   241,   117,    -1,   243,   116,   117,    -1,   243,   246,
      -1,   242,   246,    -1,    -1,   245,   246,    -1,   250,    -1,
     246,   250,    -1,   249,    -1,   247,   249,    -1,   102,    -1,
     248,   247,    -1,    40,   103,    -1,   249,    -1,    40,   103,
     113,   266,   114,   262,    -1,   102,    -1,   251,    -1,   252,
       3,   251,    -1,    -1,   113,   252,   114,    -1,    -1,    -1,
     255,   253,   256,   202,    -1,    85,   254,    -1,   241,    31,
     241,    -1,   241,    30,   241,    -1,   241,    34,   241,    -1,
     241,    33,   241,    -1,   241,    32,   241,    -1,   241,    25,
     241,    -1,   241,    24,   241,    -1,   241,    23,   241,    -1,
     241,    22,   241,    -1,   241,    21,   241,    -1,   241,    20,
     241,    -1,   241,    29,   241,    -1,   241,    28,   241,    -1,
     241,    17,   241,    -1,   241,    18,   241,    -1,   241,    19,
     241,    -1,   243,    13,   241,    -1,   243,    12,   241,    -1,
     243,    11,   241,    -1,   243,    10,   241,    -1,   243,     9,
     241,    -1,   243,     8,   241,    -1,   243,     7,   241,    -1,
     243,     6,   241,    -1,   243,     5,   241,    -1,   243,     4,
     241,    -1,    41,   248,   113,   266,   114,    -1,    31,   241,
      -1,    30,   241,    -1,   243,    37,    -1,    37,   243,    -1,
     243,    36,    -1,    36,   243,    -1,    35,   241,    -1,    45,
     113,   241,   114,    -1,    44,   113,   241,   114,    -1,   241,
      27,   137,    -1,   241,    26,   248,    -1,    80,   113,   114,
      -1,    88,   113,   114,    -1,   259,    -1,   271,    -1,   263,
      -1,   277,    -1,   257,    -1,   113,   241,   114,    -1,   113,
     241,   114,   246,    -1,    -1,    -1,   113,   241,   118,   260,
     241,   115,   261,   241,   114,    -1,    -1,    86,   254,    -1,
      86,    88,   113,   114,    -1,   102,   113,   266,   114,   262,
      -1,    -1,    92,   264,   113,   266,   114,   262,    -1,    -1,
      91,   265,   113,   266,   114,   262,    -1,    87,   113,   266,
     114,    -1,    -1,    -1,   267,   268,    -1,   269,    -1,   268,
       3,   269,    -1,    -1,   270,   241,    -1,    -1,   116,   272,
     273,   117,    -1,    -1,   274,    -1,   275,    -1,   274,     3,
     275,    -1,   241,   276,    -1,    -1,    15,   241,    -1,    -1,
     241,    16,   278,   241,    -1,    -1,   241,    14,   279,   241,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   138,   138,   138,   151,   153,   157,   158,   162,   163,
     164,   165,   166,   167,   168,   169,   173,   173,   175,   175,
     177,   177,   179,   179,   181,   181,   183,   183,   188,   192,
     196,   197,   201,   201,   207,   208,   209,   210,   211,   215,
     216,   217,   221,   222,   223,   227,   243,   252,   262,   267,
     280,   279,   290,   292,   296,   307,   313,   315,   316,   317,
     321,   322,   326,   327,   330,   332,   336,   337,   341,   349,
     350,   351,   352,   353,   354,   358,   362,   364,   368,   369,
     373,   373,   378,   379,   380,   385,   393,   399,   399,   413,
     413,   426,   426,   437,   438,   441,   443,   447,   456,   463,
     469,   470,   474,   482,   486,   487,   490,   492,   496,   496,
     500,   508,   522,   522,   545,   546,   547,   551,   558,   577,
     596,   620,   621,   625,   626,   630,   639,   650,   652,   656,
     665,   674,   683,   692,   701,   710,   721,   723,   727,   728,
     732,   733,   737,   738,   742,   751,   755,   756,   757,   758,
     761,   763,   769,   769,   777,   777,   784,   786,   790,   791,
     796,   796,   803,   804,   808,   811,   813,   817,   818,   822,
     823,   827,   828,   829,   830,   831,   832,   833,   837,   844,
     850,   850,   852,   853,   852,   855,   859,   860,   860,   865,
     865,   877,   881,   883,   887,   888,   894,   893,   902,   904,
     904,   911,   912,   912,   917,   923,   927,   928,   932,   940,
     944,   948,   949,   950,   954,   940,   966,   967,   966,   969,
     969,   973,   977,   978,   979,   983,   990,   996,  1002,  1008,
    1017,  1022,  1023,  1024,  1029,  1029,  1036,  1043,  1053,  1057,
    1067,  1068,  1069,  1069,  1074,  1075,  1079,  1080,  1084,  1089,
    1093,  1101,  1102,  1118,  1122,  1123,  1126,  1128,  1132,  1133,
    1132,  1138,  1142,  1146,  1150,  1154,  1158,  1162,  1166,  1171,
    1176,  1180,  1184,  1188,  1193,  1198,  1203,  1208,  1213,  1217,
    1221,  1225,  1229,  1233,  1238,  1243,  1248,  1253,  1258,  1269,
    1273,  1278,  1282,  1286,  1290,  1294,  1298,  1302,  1306,  1313,
    1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,  1325,  1329,
    1330,  1329,  1334,  1336,  1337,  1341,  1354,  1354,  1365,  1365,
    1376,  1390,  1396,  1396,  1406,  1407,  1411,  1411,  1415,  1415,
    1434,  1436,  1440,  1441,  1445,  1455,  1461,  1465,  1465,  1474,
    1474
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "','", "T_BINARY_XOR_ASSIGN",
  "T_BINARY_OR_ASSIGN", "T_BINARY_AND_ASSIGN", "T_RIGHT_SHIFT_ASSIGN",
  "T_LEFT_SHIFT_ASSIGN", "T_DIVIDE_ASSIGN", "T_MULT_ASSIGN",
  "T_MINUS_ASSIGN", "T_PLUS_ASSIGN", "T_ASSIGN", "T_LOGICAL_OR",
  "T_RARROW", "T_LOGICAL_AND", "T_BINARY_OR", "T_BINARY_AND",
  "T_BINARY_XOR", "T_NOTEQUAL", "T_GRTRTHAN", "T_LESSTHAN",
  "T_GRTRTHAN_EQUALS", "T_LESSTHAN_EQUALS", "T_EQUALS", "T_INSTANCEOF",
  "T_ISA", "T_RIGHT_SHIFT", "T_LEFT_SHIFT", "T_MINUS", "T_PLUS",
  "T_MODULUS", "T_DIVIDE", "T_MULT", "T_NOT_OPERATOR", "T_DECR", "T_INCR",
  "T_UPLUS", "T_UMINUS", "T_OBJOP", "T_NEW", "T_IF", "T_ELSE", "T_INCLUDE",
  "T_EVAL", "T_FUNCTION", "T_FOR", "T_WHILE", "T_DO", "T_SWITCH",
  "T_IFERR", "T_FIX", "T_CASE", "T_DEFAULT", "T_USES", "T_GLOBAL",
  "T_RETURN", "T_FINAL", "T_NAMESPACE", "T_CLASS", "T_EXTENDS", "T_BREAK",
  "T_CONTINUE", "T_STATIC", "T_MULTIPLE_ARGS", "T_MODIFIES", "T_RENAME",
  "T_ALIAS", "T_NATIVE", "T_MODULE_INIT", "T_MODULE_DEINIT",
  "T_MODULE_HEADER", "T_MODULE_FLAGS", "T_SLICE", "T_ATOMIC", "T_ERROR",
  "T_MODULE_REGISTER", "T_MODULE_UNREGISTER", "T_FOREACH", "T_ARGS",
  "T_PRIVATE", "T_PROTECTED", "T_PUBLIC", "T_ABSTRACT", "T_CLOSURE",
  "T_USING", "T_DELIVER", "T_RECIPIENT", "T_PROTOCOL", "T_IMPLEMENTS",
  "T_SELF", "T_SUPER", "T_CONSTRUCTOR", "T_DESTRUCTOR", "T_VAR_NUMBER",
  "T_VAR_STRING", "T_VAR_VOID", "T_VAR_OBJECT", "T_VAR_ARRAY", "T_QSTRING",
  "T_VARTYPE", "T_LABEL", "T_OBJPROPERTY", "T_NATIVE_CODE_BLOCK",
  "T_DOT_LABEL", "T_NNUMBER", "T_TRUE", "T_FALSE", "T_RNUMBER", "';'",
  "'{'", "'}'", "'('", "')'", "':'", "'['", "']'", "'?'", "$accept",
  "script", "@1", "script_block_list", "non_empty_script_block_list",
  "script_block", "builder_item", "@2", "@3", "@4", "@5", "@6", "@7",
  "uses_list", "module_item", "module_list", "global_decl", "@8",
  "var_type", "param_var_type", "function_name", "function_header_prefix",
  "function_parameter_declaration", "function_body", "function", "@9",
  "parameter_byref", "parameter_define_item", "parameter_multiple_args",
  "decl_parameter_list", "non_empty_decl_parameter_list",
  "namespace_header", "namespace_block_list",
  "non_empty_namespace_block_list", "namespace_delete_rename",
  "namespace_block", "namespace_def", "class_block_list",
  "non_empty_class_block_list", "class_block", "@10", "class_block_real",
  "class_header", "@11", "class_modifies_header", "@12", "implements_item",
  "@13", "implements_list", "class_implements", "standard_class",
  "modifies_class", "class_def", "class_body", "protocol_header",
  "protocol_item", "non_empty_protocol_block_list",
  "protocol_block_list_real", "protocol_block_list", "@14", "protocol_def",
  "variable_define_item", "@15", "namespace_natural_number",
  "namespace_variable_define_item", "variable_define_list",
  "namespace_variable_define_list", "class_modifier",
  "class_modifier_list", "item_modifier", "block_item_modifier_list",
  "non_empty_block_item_modifier_list", "variable_block",
  "non_empty_variable_block", "final_modifier",
  "optional_variable_type_hint_t", "optional_variable_type_hint",
  "multiple_variable_item", "@16", "namespace_multiple_variable_item",
  "@17", "namespace_variable_block", "non_empty_namespace_variable_block",
  "nested_block", "@18", "block", "case_block", "statement_block",
  "non_empty_statement_block_item", "non_empty_statement_block",
  "statement", "return_statement", "select_statement", "@19", "@20", "@21",
  "else_block", "@22", "switch_statement", "@23", "switch_case_list",
  "switch_cases_list", "non_empty_switch_cases_list", "switch_case_item",
  "@24", "default_item", "@25", "fix_else_block", "@26", "for_expression",
  "for_init_expression", "foreach_start", "itterative_statement", "@27",
  "@28", "@29", "@30", "@31", "@32", "@33", "@34", "@35", "expression",
  "cval", "cvar", "@36", "@37", "object_list", "object_no_call_list",
  "nvar", "object_property_no_call", "object_property", "lambda_argument",
  "non_empty_lambda_arguments", "lambda_arguments", "lambda_body", "@38",
  "@39", "lambda_expression", "expression_without_var",
  "question_colon_expr", "@40", "@41", "optional_function_with_clause",
  "function_call", "@42", "@43", "parameter_list", "@44",
  "non_empty_function_call_parameter_list", "function_call_parameter",
  "@45", "array_in_script", "@46", "array_elements_list",
  "non_empty_array_elements_list", "array_element", "array_element_post",
  "logical_operators", "@47", "@48", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,    44,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
      59,   123,   125,    40,    41,    58,    91,    93,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   119,   121,   120,   122,   122,   123,   123,   124,   124,
     124,   124,   124,   124,   124,   124,   126,   125,   127,   125,
     128,   125,   129,   125,   130,   125,   131,   125,   132,   133,
     134,   134,   136,   135,   137,   137,   137,   137,   137,   138,
     138,   138,   139,   139,   139,   140,   141,   142,   142,   142,
     144,   143,   145,   145,   146,   147,   148,   148,   148,   148,
     149,   149,   150,   150,   151,   151,   152,   152,   153,   154,
     154,   154,   154,   154,   154,   155,   156,   156,   157,   157,
     159,   158,   160,   160,   160,   160,   161,   162,   161,   164,
     163,   166,   165,   167,   167,   168,   168,   169,   170,   171,
     172,   172,   173,   174,   175,   175,   176,   176,   178,   177,
     179,   180,   181,   180,   182,   182,   182,   183,   183,   183,
     183,   184,   184,   185,   185,   186,   186,   187,   187,   188,
     188,   188,   188,   188,   188,   188,   189,   189,   190,   190,
     191,   191,   192,   192,   193,   193,   194,   194,   194,   194,
     195,   195,   197,   196,   199,   198,   200,   200,   201,   201,
     203,   202,   204,   204,   205,   206,   206,   207,   207,   208,
     208,   209,   209,   209,   209,   209,   209,   209,   210,   210,
     212,   211,   213,   214,   211,   211,   215,   216,   215,   218,
     217,   219,   220,   220,   221,   221,   223,   222,   224,   225,
     224,   226,   227,   226,   228,   228,   229,   229,   230,   232,
     233,   234,   235,   236,   237,   231,   238,   239,   231,   240,
     231,   231,   241,   241,   241,   242,   242,   242,   242,   242,
     243,   243,   243,   243,   244,   243,   243,   243,   243,   243,
     243,   243,   245,   243,   246,   246,   247,   247,   248,   248,
     249,   250,   250,   251,   252,   252,   253,   253,   255,   256,
     254,   257,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   258,
     258,   258,   258,   258,   258,   258,   258,   258,   258,   260,
     261,   259,   262,   262,   262,   263,   264,   263,   265,   263,
     263,   266,   267,   266,   268,   268,   270,   269,   272,   271,
     273,   273,   274,   274,   275,   276,   276,   278,   277,   279,
     277
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     4,     0,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     2,     1,     0,     3,     0,     3,
       0,     3,     0,     3,     0,     3,     0,     3,     3,     1,
       1,     3,     0,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     4,     1,     1,
       0,     4,     0,     1,     4,     1,     0,     1,     3,     1,
       1,     3,     2,     3,     0,     1,     1,     2,     4,     3,
       2,     1,     1,     1,     1,     4,     0,     1,     1,     2,
       0,     2,     3,     2,     4,     4,     1,     0,     4,     0,
       3,     0,     2,     1,     3,     0,     2,     5,     4,     3,
       1,     1,     2,     2,     1,     2,     0,     1,     0,     2,
       4,     1,     0,     4,     2,     2,     1,     1,     3,     3,
       3,     1,     3,     1,     3,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     0,     2,     3,     1,     0,     1,     1,     1,     1,
       0,     3,     0,     5,     0,     4,     0,     1,     3,     4,
       0,     5,     1,     1,     1,     0,     1,     1,     1,     1,
       2,     2,     1,     1,     2,     2,     2,     1,     1,     2,
       0,     7,     0,     0,     7,     1,     0,     0,     3,     0,
       8,     2,     0,     1,     1,     2,     0,     5,     0,     0,
       4,     0,     0,     3,     0,     1,     1,     1,     1,     0,
       0,     0,     0,     0,     0,    15,     0,     0,     7,     0,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     6,     0,     6,     5,     4,     4,     3,
       2,     2,     0,     2,     1,     2,     1,     2,     1,     2,
       2,     1,     6,     1,     1,     3,     0,     3,     0,     0,
       4,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     2,
       2,     2,     2,     2,     2,     2,     4,     4,     3,     3,
       3,     3,     1,     1,     1,     1,     1,     3,     4,     0,
       0,     9,     0,     2,     4,     5,     0,     6,     0,     6,
       4,     0,     0,     2,     1,     3,     0,     2,     0,     4,
       0,     1,     1,     3,     2,     0,     2,     0,     4,     0,
       4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       4,     0,    32,   129,     0,   130,     0,   132,    16,    18,
      24,    26,   131,    20,    22,   133,   134,   135,   126,     0,
       0,     2,     5,     6,    13,     8,     9,     0,    15,    12,
      11,     0,    10,   128,     0,   138,     0,   137,    29,    30,
       0,     0,     0,    62,     0,     0,     0,     0,     0,     0,
       0,   102,     1,   141,     7,   136,   108,     0,     0,     0,
      14,   129,   139,     0,    28,   136,    63,     0,    17,    19,
      25,    27,    21,    23,   144,   165,   140,     0,     0,     0,
     136,    74,    66,    73,    72,    71,     0,     0,   106,    89,
      86,    95,     0,   100,   101,    99,    43,    44,    42,    45,
      56,    50,    31,     0,     0,   136,    68,   242,   242,   242,
     242,   242,     0,     0,     0,     0,     0,   216,   219,   189,
     182,   178,     0,     0,   208,     0,   258,     0,     0,   231,
     232,   225,   230,   228,   226,   227,   229,   177,   160,   242,
     328,   168,     3,   169,   166,   167,     0,   172,   185,   221,
     173,     0,   223,   222,     0,   306,   224,   302,   304,   303,
     305,     0,    34,    35,    36,    37,    38,   152,   142,    75,
      67,   154,    70,     0,   110,   104,   107,   109,     0,     0,
      87,    91,     0,    80,    41,    40,    55,    39,   150,    60,
      59,     0,    57,   242,     0,    33,     0,   290,   289,   295,
     231,   232,   230,     0,   294,   292,   248,     0,   242,   242,
     242,   209,     0,   242,     0,   242,   179,   175,   176,     0,
     261,   256,   322,     0,     0,     0,   322,   141,     0,   242,
     170,   174,   339,   337,   242,   242,   242,   242,   242,   242,
     242,   242,   242,     0,     0,   242,   242,   242,   242,   242,
     242,   242,   171,     0,   241,   251,   244,   242,   242,   242,
     242,   242,   242,   242,   242,   242,   242,   293,   291,   242,
     240,   243,   143,   150,   150,    69,   105,   103,    90,     0,
      93,     0,    96,    80,     0,    80,    78,   136,     0,    52,
      46,     0,    48,   141,    51,    49,   158,     0,     0,   322,
     249,   246,     0,     0,     0,   145,   242,   163,     0,   162,
     242,   183,   300,     0,   259,     0,   326,   301,   322,   322,
       0,   165,   307,   309,   335,     0,   331,   332,   242,   242,
     275,   276,   277,   272,   271,   270,   269,   268,   267,   299,
     298,   274,   273,   263,   262,   266,   265,   264,   250,   245,
     287,   286,   285,   284,   283,   282,   281,   280,   279,   278,
     234,   239,     0,     0,     0,    88,    92,    91,     0,    98,
      79,     0,     0,    81,     0,   147,   146,   149,   148,     0,
      53,     0,    61,    58,   165,   159,   250,     0,   247,   180,
     297,   296,   207,   206,   210,   205,     0,     0,     0,     0,
     253,   254,     0,     0,   320,   323,   324,   242,     0,     0,
     312,     0,   308,   242,   242,   334,   329,   242,   340,   338,
     322,   237,   242,   242,   238,   111,   121,   153,   117,   123,
     155,    94,    97,     0,     0,    83,     0,   151,    54,     0,
     288,   242,     0,   217,   242,     0,   242,     0,   257,   260,
     326,   327,   312,   312,   258,   315,   161,     0,   336,   333,
       0,     0,   236,     0,   112,     0,     0,     0,     0,     0,
      82,    47,   186,   211,   242,     0,   192,   201,   255,   325,
     319,   317,     0,   313,   310,   312,   235,   233,   242,   122,
       0,     0,   120,   116,   119,   118,   124,    84,    85,   187,
     181,   204,   218,     0,   242,     0,   198,   193,   194,   202,
     184,     0,   242,   252,   113,   114,   115,   242,   212,   220,
     196,   190,     0,   191,   195,   242,   314,     0,   188,     0,
       0,   199,   203,   311,   213,   165,   165,   204,   197,   164,
     200,   214,     0,   242,   215
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    20,    53,    21,    22,    23,    24,    45,    46,    49,
      50,    47,    48,    25,    39,    40,    26,    41,   171,   188,
      99,    59,   101,   294,    60,   193,   381,   189,   190,   191,
     192,    27,    79,    80,    28,    82,    29,   284,   285,   286,
     287,   373,    91,   279,    92,   179,   280,   281,   282,   182,
      93,    94,    30,    95,    31,   175,   176,   177,    87,    88,
      32,   426,   488,   495,   429,   427,   430,    33,    34,    35,
      36,    37,    75,    76,    77,   379,   289,    78,   273,   173,
     274,   104,   105,   307,   227,   308,   538,   142,   143,   144,
     309,   146,   147,   441,   215,   399,   500,   517,   148,   214,
     505,   506,   507,   508,   530,   523,   536,   510,   525,   393,
     394,   149,   150,   305,   442,   501,   529,   537,   542,   212,
     474,   213,   151,   152,   153,   422,   154,   270,   300,   207,
     255,   256,   401,   402,   314,   220,   221,   403,   155,   156,
     157,   413,   512,   455,   158,   225,   224,   315,   316,   405,
     406,   407,   159,   229,   325,   326,   327,   415,   160,   329,
     328
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -466
static const short int yypact[] =
{
     765,   -63,  -466,    -4,   -40,  -466,   -41,  -466,  -466,  -466,
    -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,   -32,
      77,  -466,   765,  -466,  -466,  -466,  -466,   -27,  -466,  -466,
    -466,   -23,  -466,  -466,    30,  -466,    49,   640,  -466,  -466,
      14,     1,     8,  -466,    11,    17,    18,    27,    38,    47,
      48,  -466,  -466,   115,  -466,   196,  -466,   -35,   -61,    41,
    -466,  -466,  -466,   -63,  -466,    -1,  -466,    33,  -466,  -466,
    -466,  -466,  -466,  -466,  -466,   857,   115,    79,    56,    15,
     375,  -466,  -466,  -466,  -466,  -466,    20,    55,   256,  -466,
     109,    81,    61,  -466,  -466,  -466,  -466,  -466,  -466,  -466,
     202,  -466,  -466,    79,    68,   176,  -466,  1176,  1176,  1176,
     184,   184,    80,    93,    95,   116,   117,  -466,  -466,  -466,
    -466,  1146,    71,   122,  -466,   124,  -466,   125,   126,   129,
     130,  -466,   131,  -466,  -466,  -466,  -466,  -466,  -466,  1176,
    -466,  -466,  -466,  -466,   857,  -466,   137,  -466,  -466,  -466,
    -466,   650,   195,    39,   195,  -466,  -466,  -466,  -466,  -466,
    -466,   139,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,
    -466,  -466,  -466,   140,  -466,  -466,   256,  -466,    49,   147,
    -466,  -466,   142,   154,  -466,  -466,  -466,  -466,   246,  -466,
    -466,   155,   267,   941,   162,  -466,    79,  -466,  -466,  -466,
    -466,  -466,  -466,   195,   -22,   -22,  -466,   -16,  1176,  1176,
    1176,  -466,   160,  1025,   168,  1025,  1300,  -466,  -466,   180,
    -466,   182,   190,   191,   183,   197,   190,   115,   169,   689,
    -466,  -466,  -466,  -466,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,    80,    79,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  -466,   179,   195,  -466,  -466,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  -466,  -466,   655,
     195,   195,  -466,   246,   246,  -466,  -466,  -466,  -466,   198,
    -466,   212,   315,   154,   207,   211,  -466,   326,    23,   306,
    -466,   202,  -466,   115,  -466,  -466,  -466,   216,   224,   190,
     289,  -466,   472,   498,   519,  1062,  1176,  -466,   282,  -466,
    1176,  -466,  -466,   230,  -466,   220,  -466,  -466,   190,   190,
     221,   857,   195,  -466,  1279,   219,   337,  -466,  1176,  1176,
    1354,  1370,   901,   189,   189,   189,   189,   189,   189,   289,
    -466,   421,   421,    70,    70,  -466,  -466,  -466,   228,  -466,
    1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,  1300,
     247,  -466,   328,   283,   284,  -466,  -466,  -466,   276,  -466,
    -466,   287,   290,  -466,    20,  -466,  -466,  -466,  -466,   370,
    -466,   294,  -466,  -466,   857,  -466,  -466,   285,  -466,  -466,
    -466,  -466,  -466,  -466,  -466,  1300,   551,   291,   573,   345,
    -466,  -466,    12,   295,  -466,   395,  -466,  1176,   317,   318,
     319,   325,   195,  1176,  1176,  -466,  -466,  1176,  1319,  1337,
     190,  -466,  1176,   773,  -466,   425,  -466,   437,   428,  -466,
     440,  -466,  -466,   344,   346,  -466,   339,  -466,  -466,   335,
    -466,  1025,   397,  -466,  1176,   398,  1025,   230,  -466,  -466,
    -466,  1300,   319,   319,   420,  -466,  -466,   451,  1300,  -466,
     441,   349,  -466,   396,  -466,   283,    -8,   284,   400,   401,
    -466,  -466,   491,  -466,  1025,   597,   501,   513,  -466,  -466,
    -466,  -466,   444,  -466,  -466,   319,  -466,  -466,  1176,  -466,
     452,   453,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,
    -466,  1146,  -466,   450,  1176,   449,   508,   501,  -466,  -466,
    -466,   474,  1176,  -466,  1300,  -466,  -466,  1025,  -466,  -466,
    1300,  -466,   448,  -466,  -466,  1025,  -466,   618,  -466,   454,
     493,  -466,  -466,  -466,  -466,   857,   857,  1146,  -466,  -466,
    -466,  -466,   495,  1025,  -466
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -466,  -466,  -466,  -466,  -466,   588,  -466,  -466,  -466,  -466,
    -466,  -466,  -466,  -466,   590,  -466,  -466,  -466,   -65,  -466,
    -466,  -466,  -466,  -466,   -85,  -466,  -466,   363,   364,  -466,
    -466,  -466,  -466,  -466,    -2,   576,     3,   374,  -466,   373,
    -466,  -466,  -466,  -466,  -466,  -466,   292,  -466,  -466,  -466,
    -466,  -466,     5,  -466,  -466,   484,  -466,  -466,  -466,  -466,
       9,   223,  -466,  -466,   194,  -466,  -466,  -466,  -466,   625,
     -46,  -466,  -202,  -466,  -466,  -466,  -244,   -72,  -466,  -100,
    -466,  -466,  -466,   -75,  -466,  -210,  -466,  -311,   545,  -466,
     -73,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,
    -466,  -466,  -466,   156,  -466,  -466,  -466,  -466,  -466,  -465,
    -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,  -466,
    -466,  -466,  -101,   -71,   -11,  -466,  -466,  -138,  -466,   458,
    -186,  -243,   248,  -466,  -466,   239,  -466,  -466,  -466,  -466,
    -466,  -466,  -466,  -398,  -466,  -466,  -466,  -213,  -466,  -466,
     244,  -466,  -466,  -466,  -466,  -466,   280,  -466,  -466,  -466,
    -466
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -331
static const short int yytable[] =
{
     141,   172,   145,   194,   161,   311,   197,   198,   199,    86,
     411,   349,   167,   320,   254,   447,   271,    63,   253,   103,
     216,   301,   490,   491,   298,   321,    42,   349,   349,   363,
     364,    89,    96,    97,    86,   187,   518,    38,   228,   203,
     203,    98,   178,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    81,   480,   481,  -125,    61,    83,   196,
      84,    44,    43,     5,    85,   254,    58,    90,     7,   141,
      51,   145,   541,   439,    12,   267,   268,    52,    81,   253,
      15,    16,    17,    83,    55,    84,   387,   513,    56,    85,
      57,   384,   492,   277,   269,    58,   297,   299,   493,   204,
     205,   494,   249,   250,   251,   408,   409,   302,   303,   304,
      66,  -156,    65,    67,   388,   162,   163,   164,   165,   166,
     295,    68,    69,   375,    64,   376,   448,   169,   324,   377,
     178,    70,   378,   330,   331,   332,   333,   334,   335,   336,
     337,   338,    71,   106,   341,   342,   343,   344,   345,   346,
     347,    72,    73,   301,   100,   269,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   168,   174,   362,   349,
     180,   181,   183,    74,   162,   163,   164,   165,   166,   340,
     195,   217,   206,   232,   412,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   395,   396,   208,   460,   209,   398,
    -145,  -145,  -145,  -145,  -145,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   539,   540,   187,   418,   419,   210,
     211,   472,   218,   392,    61,   253,   477,   219,   222,   223,
       5,   374,  -318,  -316,   226,     7,   141,   231,   145,   272,
     275,    12,   278,   283,     3,     4,  -127,    15,    16,    17,
       5,   184,   185,     6,   502,     7,   -76,   186,   288,   290,
     291,    12,   296,   306,   436,   200,   201,    15,    16,    17,
      18,   310,   348,   322,   131,    19,   202,   323,  -157,   435,
     133,   134,   135,   136,   312,   313,   318,   162,   163,   164,
     165,   166,  -136,   365,  -321,   317,   451,   528,   -64,   141,
     319,   145,   457,   458,    61,   532,   324,   366,   367,   369,
       5,   461,   463,   -77,   380,     7,   385,   386,   449,   298,
     397,    12,   400,   544,   404,   410,   416,    15,    16,    17,
     417,   420,   232,   475,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   232,   421,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,    61,   425,   428,   514,   432,   433,
       5,   437,   434,   371,   372,     7,   438,   446,   450,   440,
     395,    12,   423,   520,   444,   454,   138,    15,    16,    17,
     232,   527,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   452,   453,     3,     4,  -127,   395,   456,   464,     5,
     465,   466,     6,   467,     7,   424,   468,   471,   469,   470,
      12,   247,   248,   249,   250,   251,    15,    16,    17,    18,
     141,   141,   145,   145,    19,   232,   486,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   232,   -65,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   473,   482,   476,
     497,   498,   232,   487,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   232,   499,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   504,   485,   509,   511,   515,   516,
     519,   521,   522,   531,   534,   232,   484,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   389,   232,   526,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   535,   543,
      54,   232,   390,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   232,   391,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   102,   382,   383,   170,   368,   370,   431,
     276,   496,    62,   524,   232,   443,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   107,   108,   445,   489,   230,
     109,   110,   111,   483,   479,   478,   112,   459,    61,   114,
     115,   339,     0,     0,     5,     0,     0,     0,     0,     7,
       0,   503,     0,     0,     0,    12,     0,     0,     0,   107,
     108,    15,    16,    17,   109,   110,   111,     0,     0,   360,
     112,     0,   533,   114,   115,   125,     0,     0,     0,     0,
     126,     0,   127,   128,     0,     0,   129,   130,     0,     0,
       0,     0,     0,     0,     0,   131,     0,   132,     0,     0,
     252,   133,   134,   135,   136,     0,     0,     0,   139,   125,
       0,   140,   361,     0,   126,     0,   127,   128,     0,     0,
     129,   130,     0,     0,     0,     0,     0,     0,     0,   131,
       0,   132,     0,     0,     0,   133,   134,   135,   136,     0,
       0,     0,   139,   107,   108,   140,  -330,     0,   109,   110,
     111,  -136,     0,     0,   112,     0,     0,   114,   115,     0,
       1,     2,     0,     3,     4,  -127,     0,     0,     0,     5,
       0,     0,     6,     0,     7,     8,     9,    10,    11,     0,
      12,     0,    13,    14,     0,     0,    15,    16,    17,    18,
       0,     0,     0,   125,    19,     0,     0,     0,   126,     0,
     127,   128,     0,     0,   129,   130,     0,     0,     0,     0,
       0,     0,     0,   131,     0,   132,     0,     0,     0,   133,
     134,   135,   136,     0,     0,     0,   139,   107,   108,   140,
     462,     0,   109,   110,   111,     0,     0,  -242,   112,   113,
       0,   114,   115,     0,   116,   117,   118,   119,   120,     0,
       0,     0,     0,     0,   121,     0,     0,     0,     0,   122,
     123,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   124,   125,     0,     0,
       0,     0,   126,     0,   127,   128,     0,     0,   129,   130,
       0,     0,     0,     0,     0,     0,     0,   131,     0,   132,
       0,     0,     0,   133,   134,   135,   136,   137,   138,     0,
     139,   107,   108,   140,     0,     0,   109,   110,   111,     0,
       0,     0,   112,   113,     0,   114,   115,     0,   116,   117,
     118,   119,   120,     0,     0,     0,     0,     0,   121,     0,
       0,     0,     0,   122,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     124,   125,     0,     0,     0,     0,   126,     0,   127,   128,
       0,     0,   129,   130,     0,     0,     0,     0,     0,     0,
       0,   131,     0,   132,     0,   292,     0,   133,   134,   135,
     136,   137,   293,     0,   139,   107,   108,   140,     0,     0,
     109,   110,   111,     0,     0,     0,   112,   113,     0,   114,
     115,     0,   116,   117,   118,   119,   120,     0,     0,     0,
       0,     0,   121,     0,     0,     0,     0,   122,   123,     0,
       0,     0,   107,   108,     0,     0,     0,   109,   110,   111,
       0,     0,  -242,   112,   124,   125,   114,   115,     0,     0,
     126,     0,   127,   128,     0,     0,   129,   130,     0,     0,
      74,     0,     0,     0,     0,   131,     0,   132,     0,     0,
       0,   133,   134,   135,   136,   137,   138,     0,   139,     0,
       0,   140,   125,     0,     0,     0,     0,   126,     0,   127,
     128,     0,     0,   129,   130,     0,     0,     0,     0,     0,
       0,     0,   131,     0,   132,     0,     0,     0,   133,   134,
     135,   136,  -204,     0,     0,   139,   107,   108,   140,     0,
       0,   109,   110,   111,     0,     0,  -242,   112,     0,     0,
     114,   115,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   107,   108,     0,     0,
       0,   109,   110,   111,     0,     0,     0,   112,     0,     0,
     114,   115,     0,     0,     0,     0,   125,     0,     0,     0,
       0,   126,     0,   127,   128,     0,     0,   129,   130,     0,
       0,     0,     0,     0,     0,     0,   131,     0,   132,     0,
       0,     0,   133,   134,   135,   136,   125,     0,     0,   139,
       0,   126,   140,   127,   128,     0,     0,   129,   130,     0,
       0,     0,     0,     0,     0,     0,   131,     0,   132,     0,
       0,     0,   133,   134,   135,   136,     0,     0,     0,   139,
       0,     0,   140,   232,   414,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   232,     0,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251
};

static const short int yycheck[] =
{
      75,    86,    75,   103,    76,   215,   107,   108,   109,    55,
     321,   254,    77,   226,   152,     3,   154,     3,    40,    65,
     121,   207,    30,    31,    40,   227,    66,   270,   271,   273,
     274,    66,    93,    94,    80,   100,   501,   100,   139,   110,
     111,   102,    88,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    55,   452,   453,    60,    58,    55,   105,
      55,   102,   102,    64,    55,   203,    46,   102,    69,   144,
     102,   144,   537,   384,    75,    36,    37,     0,    80,    40,
      81,    82,    83,    80,   111,    80,   299,   485,   111,    80,
      60,   293,   100,   178,   116,    46,   196,   113,   106,   110,
     111,   109,    32,    33,    34,   318,   319,   208,   209,   210,
     102,   112,   111,   102,   300,    95,    96,    97,    98,    99,
     193,   104,   104,   100,   110,   102,   114,   112,   229,   106,
     176,   104,   109,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   104,   110,   245,   246,   247,   248,   249,   250,
     251,   104,   104,   339,   113,   116,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   110,   112,   269,   412,
      61,    90,   111,    58,    95,    96,    97,    98,    99,   244,
     112,   110,   102,    14,   322,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,   305,   306,   113,   420,   113,   310,
      95,    96,    97,    98,    99,    26,    27,    28,    29,    30,
      31,    32,    33,    34,   535,   536,   291,   328,   329,   113,
     113,   441,   110,   305,    58,    40,   446,   113,   113,   113,
      64,   287,   113,   113,   113,    69,   321,   110,   321,   110,
     110,    75,   105,   111,    58,    59,    60,    81,    82,    83,
      64,    59,    60,    67,   474,    69,   112,    65,    22,   114,
       3,    75,   110,   113,   374,    91,    92,    81,    82,    83,
      84,   113,   103,   114,   100,    89,   102,   118,   112,   374,
     106,   107,   108,   109,   114,   113,   113,    95,    96,    97,
      98,    99,    46,   105,   114,   114,   407,   517,   112,   384,
     113,   384,   413,   414,    58,   525,   417,   105,     3,   112,
      64,   422,   423,   112,    18,    69,   110,   103,   403,    40,
      48,    75,   102,   543,   114,   114,   117,    81,    82,    83,
       3,   113,    14,   444,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    14,   117,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    58,   102,   102,   488,   112,   102,
      64,    21,   102,    67,    68,    69,   102,    52,     3,   114,
     501,    75,    74,   504,   113,    86,   111,    81,    82,    83,
      14,   512,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,   114,   114,    58,    59,    60,   537,   112,    13,    64,
       3,    13,    67,     3,    69,   117,   102,   112,   102,   110,
      75,    30,    31,    32,    33,    34,    81,    82,    83,    84,
     535,   536,   535,   536,    89,    14,   117,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    14,   112,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,   110,    88,   111,
     110,   110,    14,   117,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    14,    43,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    53,   114,    43,   113,   106,   106,
     110,   112,    54,   115,   110,    14,   115,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,   114,    14,   114,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,   115,   114,
      22,    14,   114,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    14,   114,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    63,   291,   291,    80,   283,   285,   367,
     176,   467,    37,   507,    14,   114,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    30,    31,   114,   465,   144,
      35,    36,    37,   454,   450,   447,    41,   417,    58,    44,
      45,   243,    -1,    -1,    64,    -1,    -1,    -1,    -1,    69,
      -1,   114,    -1,    -1,    -1,    75,    -1,    -1,    -1,    30,
      31,    81,    82,    83,    35,    36,    37,    -1,    -1,    74,
      41,    -1,   114,    44,    45,    80,    -1,    -1,    -1,    -1,
      85,    -1,    87,    88,    -1,    -1,    91,    92,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,    -1,   102,    -1,    -1,
     110,   106,   107,   108,   109,    -1,    -1,    -1,   113,    80,
      -1,   116,   117,    -1,    85,    -1,    87,    88,    -1,    -1,
      91,    92,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
      -1,   102,    -1,    -1,    -1,   106,   107,   108,   109,    -1,
      -1,    -1,   113,    30,    31,   116,   117,    -1,    35,    36,
      37,    46,    -1,    -1,    41,    -1,    -1,    44,    45,    -1,
      55,    56,    -1,    58,    59,    60,    -1,    -1,    -1,    64,
      -1,    -1,    67,    -1,    69,    70,    71,    72,    73,    -1,
      75,    -1,    77,    78,    -1,    -1,    81,    82,    83,    84,
      -1,    -1,    -1,    80,    89,    -1,    -1,    -1,    85,    -1,
      87,    88,    -1,    -1,    91,    92,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,   102,    -1,    -1,    -1,   106,
     107,   108,   109,    -1,    -1,    -1,   113,    30,    31,   116,
     117,    -1,    35,    36,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    62,
      63,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    79,    80,    -1,    -1,
      -1,    -1,    85,    -1,    87,    88,    -1,    -1,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,   102,
      -1,    -1,    -1,   106,   107,   108,   109,   110,   111,    -1,
     113,    30,    31,   116,    -1,    -1,    35,    36,    37,    -1,
      -1,    -1,    41,    42,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    -1,    85,    -1,    87,    88,
      -1,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,   102,    -1,   104,    -1,   106,   107,   108,
     109,   110,   111,    -1,   113,    30,    31,   116,    -1,    -1,
      35,    36,    37,    -1,    -1,    -1,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    -1,
      -1,    -1,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    30,    31,    -1,    -1,    -1,    35,    36,    37,
      -1,    -1,    40,    41,    79,    80,    44,    45,    -1,    -1,
      85,    -1,    87,    88,    -1,    -1,    91,    92,    -1,    -1,
      58,    -1,    -1,    -1,    -1,   100,    -1,   102,    -1,    -1,
      -1,   106,   107,   108,   109,   110,   111,    -1,   113,    -1,
      -1,   116,    80,    -1,    -1,    -1,    -1,    85,    -1,    87,
      88,    -1,    -1,    91,    92,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,    -1,   102,    -1,    -1,    -1,   106,   107,
     108,   109,   110,    -1,    -1,   113,    30,    31,   116,    -1,
      -1,    35,    36,    37,    -1,    -1,    40,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    -1,    -1,
      -1,    35,    36,    37,    -1,    -1,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    -1,    -1,    80,    -1,    -1,    -1,
      -1,    85,    -1,    87,    88,    -1,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,   102,    -1,
      -1,    -1,   106,   107,   108,   109,    80,    -1,    -1,   113,
      -1,    85,   116,    87,    88,    -1,    -1,    91,    92,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,   102,    -1,
      -1,    -1,   106,   107,   108,   109,    -1,    -1,    -1,   113,
      -1,    -1,   116,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    14,    -1,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,    55,    56,    58,    59,    64,    67,    69,    70,    71,
      72,    73,    75,    77,    78,    81,    82,    83,    84,    89,
     120,   122,   123,   124,   125,   132,   135,   150,   153,   155,
     171,   173,   179,   186,   187,   188,   189,   190,   100,   133,
     134,   136,    66,   102,   102,   126,   127,   130,   131,   128,
     129,   102,     0,   121,   124,   111,   111,    60,    46,   140,
     143,    58,   188,     3,   110,   111,   102,   102,   104,   104,
     104,   104,   104,   104,    58,   191,   192,   193,   196,   151,
     152,   153,   154,   155,   171,   179,   189,   177,   178,    66,
     102,   161,   163,   169,   170,   172,    93,    94,   102,   139,
     113,   141,   133,   189,   200,   201,   110,    30,    31,    35,
      36,    37,    41,    42,    44,    45,    47,    48,    49,    50,
      51,    57,    62,    63,    79,    80,    85,    87,    88,    91,
      92,   100,   102,   106,   107,   108,   109,   110,   111,   113,
     116,   202,   206,   207,   208,   209,   210,   211,   217,   230,
     231,   241,   242,   243,   245,   257,   258,   259,   263,   271,
     277,   196,    95,    96,    97,    98,    99,   137,   110,   112,
     154,   137,   143,   198,   112,   174,   175,   176,   189,   164,
      61,    90,   168,   111,    59,    60,    65,   137,   138,   146,
     147,   148,   149,   144,   198,   112,   189,   241,   241,   241,
      91,    92,   102,   242,   243,   243,   102,   248,   113,   113,
     113,   113,   238,   240,   218,   213,   241,   110,   110,   113,
     254,   255,   113,   113,   265,   264,   113,   203,   241,   272,
     207,   110,    14,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,   110,    40,   246,   249,   250,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    36,    37,   116,
     246,   246,   110,   197,   199,   110,   174,   143,   105,   162,
     165,   166,   167,   111,   156,   157,   158,   159,    22,   195,
     114,     3,   104,   111,   142,   209,   110,   198,    40,   113,
     247,   249,   241,   241,   241,   232,   113,   202,   204,   209,
     113,   204,   114,   113,   253,   266,   267,   114,   113,   113,
     266,   191,   114,   118,   241,   273,   274,   275,   279,   278,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   248,
     137,   241,   241,   241,   241,   241,   241,   241,   103,   250,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
      74,   117,   241,   195,   195,   105,   105,     3,   156,   112,
     158,    67,    68,   160,   189,   100,   102,   106,   109,   194,
      18,   145,   146,   147,   191,   110,   103,   266,   249,   114,
     114,   114,   196,   228,   229,   241,   241,    48,   241,   214,
     102,   251,   252,   256,   114,   268,   269,   270,   266,   266,
     114,   206,   246,   260,    15,   276,   117,     3,   241,   241,
     113,   117,   244,    74,   117,   102,   180,   184,   102,   183,
     185,   165,   112,   102,   102,   143,   198,    21,   102,   206,
     114,   212,   233,   114,   113,   114,    52,     3,   114,   202,
       3,   241,   114,   114,    86,   262,   112,   241,   241,   275,
     266,   241,   117,   241,    13,     3,    13,     3,   102,   102,
     110,   112,   204,   110,   239,   241,   111,   204,   251,   269,
     262,   262,    88,   254,   115,   114,   117,   117,   181,   180,
      30,    31,   100,   106,   109,   182,   183,   110,   110,    43,
     215,   234,   204,   114,    53,   219,   220,   221,   222,    43,
     226,   113,   261,   262,   241,   106,   106,   216,   228,   110,
     241,   112,    54,   224,   222,   227,   114,   241,   204,   235,
     223,   115,   204,   114,   110,   115,   225,   236,   205,   206,
     206,   228,   237,   114,   204
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 138 "ferite_parser.y"
    { 
                                        ferite_do_function_header( "!__start__", FE_FALSE, FE_FALSE, FE_FALSE, FE_ITEM_IS_PUBLIC, FE_FALSE ); 
                                        ferite_var_array_count = 0 
                                    ;}
    break;

  case 3:
#line 143 "ferite_parser.y"
    {
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "forced-function-return", FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        ferite_do_function_footer();
                                    ;}
    break;

  case 16:
#line 173 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 17:
#line 174 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-init", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 18:
#line 175 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 19:
#line 176 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-deinit", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 20:
#line 177 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 21:
#line 178 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-register", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 22:
#line 179 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 23:
#line 180 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-unregister", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 24:
#line 181 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 25:
#line 182 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-header", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 26:
#line 183 "ferite_parser.y"
    { ferite_scanner_go_native(); ;}
    break;

  case 27:
#line 184 "ferite_parser.y"
    { ferite_do_create_builder_variable( "'module-flags", (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); ;}
    break;

  case 29:
#line 192 "ferite_parser.y"
    { FECT; ferite_do_uses( (yyvsp[0].text) ); ffree((yyvsp[0].text)); ;}
    break;

  case 32:
#line 201 "ferite_parser.y"
    { FUD(( "going into global block\n" )); ferite_var_is_global = FE_TRUE; ;}
    break;

  case 33:
#line 203 "ferite_parser.y"
    { ferite_var_is_global = FE_FALSE; FUD(( "leaving global memory block\n" )); ;}
    break;

  case 34:
#line 207 "ferite_parser.y"
    { ferite_last_type = F_VAR_NUM; ;}
    break;

  case 35:
#line 208 "ferite_parser.y"
    { ferite_last_type = F_VAR_STR; ;}
    break;

  case 36:
#line 209 "ferite_parser.y"
    { ferite_last_type = F_VAR_VOID; ;}
    break;

  case 37:
#line 210 "ferite_parser.y"
    { ferite_last_type = F_VAR_OBJ; ;}
    break;

  case 38:
#line 211 "ferite_parser.y"
    { ferite_last_type = F_VAR_UARRAY; ;}
    break;

  case 40:
#line 216 "ferite_parser.y"
    { ferite_last_type = F_VAR_CLASS; ;}
    break;

  case 41:
#line 217 "ferite_parser.y"
    { ferite_last_type = F_VAR_NS; ;}
    break;

  case 42:
#line 221 "ferite_parser.y"
    { ferite_last_function = (yyvsp[0].text); ;}
    break;

  case 43:
#line 222 "ferite_parser.y"
    { ferite_last_function = fstrdup( "constructor" ); ;}
    break;

  case 44:
#line 223 "ferite_parser.y"
    { ferite_last_function = fstrdup( "destructor" ); ;}
    break;

  case 45:
#line 227 "ferite_parser.y"
    {
                                        if( ferite_var_is_final )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'final' can not be applied to functions ('%s' on line %d in %s)\n", ferite_last_function, ferite_scanner_lineno, ferite_scanner_file );
                                        ferite_do_function_header( ferite_last_function, ferite_var_is_static, ferite_var_is_native, ferite_var_is_atomic, ferite_item_state, ferite_var_is_final );
                                        ffree( ferite_last_function ); FECT;
                                        ferite_var_is_params = FE_TRUE;
                                        ferite_var_is_static = FE_FALSE;
                                        ferite_var_is_atomic = FE_FALSE;
                                        ferite_var_array_count = FE_FALSE;
                                        ferite_var_is_final = FE_FALSE; 
                                        ferite_item_state = FE_ITEM_IS_PRIVATE;
                                    ;}
    break;

  case 46:
#line 243 "ferite_parser.y"
    { 
                                        ferite_var_is_params = FE_FALSE;
                                        ferite_do_function_start();
                                        FUD(("PARSER: END FUNCTION PARAMETER DECLARATION\n"));
                                        FUD(("PARSER: BEGIN FUNCTION BODY\n")); 
                                    ;}
    break;

  case 47:
#line 254 "ferite_parser.y"
    { 
                                        FUD(("PARSER: END FUNCTION BODY\n"));
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "forced-function-return", FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(voidptr)        \n"));
                                        ferite_do_function_footer();
                                    ;}
    break;

  case 48:
#line 262 "ferite_parser.y"
    { 
                                        ferite_do_function_native_block( (yyvsp[0].text),
                                        ferite_current_native_block_file, 
                                        ferite_current_native_block_line ); 
                                    ;}
    break;

  case 49:
#line 267 "ferite_parser.y"
    {
    
                                        FUD(("PARSER: END FUNCTION BODY\n"));
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "forced-function-return", FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(voidptr)        \n"));
                                        ferite_do_function_footer();    
                                    ;}
    break;

  case 50:
#line 280 "ferite_parser.y"
    { 
                                        if( ferite_var_is_native == FE_TRUE )
                                        {
                                            ferite_scanner_go_native(); 
                                            ferite_var_is_native = FE_FALSE;
                                        }
                                    ;}
    break;

  case 53:
#line 292 "ferite_parser.y"
    { ferite_var_pass_type = FE_BY_REF; ;}
    break;

  case 54:
#line 298 "ferite_parser.y"
    {  
                                        FUD(("PARSER: Parameter Declared         %s (%d)\n", (yyvsp[0].text), ferite_last_type)); 
                                        ferite_do_add_variable_to_paramlist( (yyvsp[0].text), ferite_last_type, ferite_var_pass_type );
                                        ffree( (yyvsp[0].text) ); FECT;
                                        ferite_var_pass_type = FE_BY_VALUE;
                                    ;}
    break;

  case 55:
#line 307 "ferite_parser.y"
    {
                                        FUD(("PARSER: Parameter Declared - Multiple Args\n"));
                                        ferite_do_add_variable_to_paramlist( "...", F_VAR_VOID, FE_BY_VALUE );
                                    ;}
    break;

  case 62:
#line 326 "ferite_parser.y"
    { ferite_do_namespace_header( (yyvsp[0].text) ); ffree( (yyvsp[0].text) ); FECT; ;}
    break;

  case 63:
#line 327 "ferite_parser.y"
    { ferite_do_namespace_extends( (yyvsp[0].text) ); ffree( (yyvsp[0].text) );  FECT; ;}
    break;

  case 68:
#line 341 "ferite_parser.y"
    {
                                        FUD(("Renaming class item\n"));
                                        ferite_do_namespace_item_rename( (yyvsp[-2].text), (yyvsp[-1].text) );
                                        ffree( (yyvsp[-2].text) ); FECT; ffree( (yyvsp[-1].text) ); FECT;
                                    ;}
    break;

  case 75:
#line 359 "ferite_parser.y"
    { ferite_do_namespace_footer(); ;}
    break;

  case 80:
#line 373 "ferite_parser.y"
    { ferite_item_state = -1; ;}
    break;

  case 84:
#line 380 "ferite_parser.y"
    {
                                        FUD(("Renaming class item\n"));
                                        ferite_do_class_item_rename( (yyvsp[-2].text), (yyvsp[-1].text) );
                                        ffree( (yyvsp[-2].text) ); FECT; ffree( (yyvsp[-1].text) ); FECT;
                                    ;}
    break;

  case 85:
#line 385 "ferite_parser.y"
    {
                                        FUD(("Aliasing class item\n"));
                                        ferite_do_class_function_alias( (yyvsp[-2].text), (yyvsp[-1].text) );
                                        ffree( (yyvsp[-2].text) ); FECT; ffree( (yyvsp[-1].text) ); FECT;
                                    ;}
    break;

  case 86:
#line 393 "ferite_parser.y"
    {   
                                        FUD(("CLASS START\n" ));
                                        ferite_do_class_header( (yyvsp[0].text), NULL, ferite_class_state );
                                        ferite_class_state = 0;
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 87:
#line 399 "ferite_parser.y"
    {
                                        ferite_scanner_want_dot_label();
                                    ;}
    break;

  case 88:
#line 402 "ferite_parser.y"
    {   
                                        FUD(("CLASS START\n" ));
                                        ferite_scanner_stop_dot_label();
                                        ferite_do_class_header( (yyvsp[-3].text), (yyvsp[0].text), ferite_class_state );
                                        ferite_class_state = 0;
                                        ffree( (yyvsp[-3].text) ); FECT;
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 89:
#line 413 "ferite_parser.y"
    {
                                        ferite_scanner_want_dot_label();
                                    ;}
    break;

  case 90:
#line 416 "ferite_parser.y"
    {
                                        FUD(("CLASS START\n" ));
                                        ferite_scanner_stop_dot_label();
                                        ferite_do_class_header( NULL, (yyvsp[0].text), ferite_class_state );
                                        ferite_class_state = 0;
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 91:
#line 426 "ferite_parser.y"
    {
                                        ferite_scanner_want_dot_label();
                                    ;}
    break;

  case 92:
#line 429 "ferite_parser.y"
    {
                                        ferite_scanner_stop_dot_label();
                                        ferite_do_class_implements( (yyvsp[0].text) );
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 97:
#line 449 "ferite_parser.y"
    {
                                        FUD(("CLASS END\n" ));
                                        ferite_do_class_footer();
                                    ;}
    break;

  case 98:
#line 457 "ferite_parser.y"
    {
                                        ferite_do_class_footer();
                                    ;}
    break;

  case 102:
#line 474 "ferite_parser.y"
    {
                            ferite_do_class_header( (yyvsp[0].text), NULL, FE_ITEM_IS_PROTOCOL );
                            ferite_class_state = 0;
                            ffree( (yyvsp[0].text) ); FECT;
                        ;}
    break;

  case 108:
#line 496 "ferite_parser.y"
    { ferite_class_state = -1; ;}
    break;

  case 110:
#line 501 "ferite_parser.y"
    {
                                        ferite_do_class_footer();
                                    ;}
    break;

  case 111:
#line 508 "ferite_parser.y"
    {  
                                        FUD(("PARSER: Variable Declared         %s(%d)\n", (yyvsp[0].text), ferite_last_type)); 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[0].text), ferite_scanner_lineno, ferite_scanner_file );
                                        ferite_do_add_variable( (yyvsp[0].text), ferite_last_type, ferite_var_is_global, ferite_var_is_final, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                        
                                        if( ferite_last_type == F_VAR_VOID )
                                        {
                                            ferite_do_variable_push( (yyvsp[0].text) );
                                            ferite_do_void_reset();
                                        }
                                        
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 112:
#line 522 "ferite_parser.y"
    {  
                                        FUD(("PARSER: Variable Declared         %s(%d)\n", (yyvsp[-1].text), ferite_last_type)); 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[-1].text), ferite_scanner_lineno, ferite_scanner_file );
                                        ferite_do_add_variable( (yyvsp[-1].text), ferite_last_type, FE_FALSE, ferite_var_is_final, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                        
                                        if( ferite_last_type == F_VAR_VOID )
                                        {
                                            ferite_do_variable_push( (yyvsp[-1].text) );
                                            ferite_do_void_reset();
                                        }
                                        
                                        ferite_do_variable_push( (yyvsp[-1].text) );
                                        ffree( (yyvsp[-1].text) ); FECT; 
                                    ;}
    break;

  case 113:
#line 537 "ferite_parser.y"
    {  
                                        ferite_do_binary_op( FERITE_OPCODE_assign );            
                                        FUD(("PARSER: op->assign       pop,pop\n")); 
                                        ferite_do_pop();
                                    ;}
    break;

  case 114:
#line 545 "ferite_parser.y"
    {   ferite_namespace_naturaln = 0 - (yyvsp[0].inumber); ;}
    break;

  case 115:
#line 546 "ferite_parser.y"
    {   ferite_namespace_naturaln = (yyvsp[0].inumber); ;}
    break;

  case 116:
#line 547 "ferite_parser.y"
    {   ferite_namespace_naturaln = (yyvsp[0].inumber); ;}
    break;

  case 117:
#line 551 "ferite_parser.y"
    {  
                                        FUD(("PARSER: Variable Declared         %s(%d)\n", (yyvsp[0].text), ferite_last_type)); 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[0].text), ferite_scanner_lineno, ferite_scanner_file );
                                        ferite_do_add_variable( (yyvsp[0].text), ferite_last_type, ferite_var_is_global, ferite_var_is_final, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 118:
#line 558 "ferite_parser.y"
    { 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[-2].text), ferite_scanner_lineno, ferite_scanner_file );
                                        if( ferite_last_type == F_VAR_NUM )
                                        {
                                            FUD(("PARSER: Variable Declared         %s(%d)=%d\n", (yyvsp[-2].text), ferite_last_type, ferite_namespace_naturaln )); 
                                            ferite_temp_variable = ferite_create_number_long_variable( NULL, (yyvsp[-2].text), ferite_namespace_naturaln, FE_ALLOC );
                                            if( ferite_var_is_final )
                                              MARK_VARIABLE_AS_FINALSET( ferite_temp_variable );
                                            ferite_do_add_variable_with_value( (yyvsp[-2].text), ferite_temp_variable, ferite_var_is_global, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                            ffree( (yyvsp[-2].text) ); FECT;
                                        } 
                                        else 
                                        {
                                            ferite_error( ferite_current_compile->script, 0, "Can't initialise variable '%s' of type '%s' with the number %d.\n", (yyvsp[-2].text), ferite_variable_id_to_str( NULL,ferite_last_type), ferite_namespace_naturaln );
                                            ffree( (yyvsp[-2].text) ); FECT;
                                            feperror( NULL );
                                        }
                                    ;}
    break;

  case 119:
#line 577 "ferite_parser.y"
    { 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[-2].text), ferite_scanner_lineno, ferite_scanner_file );
                                        if( ferite_last_type == F_VAR_NUM )
                                        {
                                            FUD(("PARSER: Variable Declared         %s(%d)=%f\n", (yyvsp[-2].text), ferite_last_type, (yyvsp[0].fnumber))); 
                                            ferite_temp_variable = ferite_create_number_double_variable( NULL, (yyvsp[-2].text), (yyvsp[0].fnumber), FE_ALLOC );
                                            if( ferite_var_is_final )
                                              MARK_VARIABLE_AS_FINALSET( ferite_temp_variable );
                                            ferite_do_add_variable_with_value( (yyvsp[-2].text), ferite_temp_variable, ferite_var_is_global, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                            ffree( (yyvsp[-2].text) ); FECT;
                                        } 
                                        else 
                                        {
                                            ferite_error( ferite_current_compile->script, 0, "Can't initialise variable '%s' of type '%s' with the number %f.\n", (yyvsp[-2].text), ferite_variable_id_to_str( NULL,ferite_last_type), (yyvsp[0].fnumber) );
                                            ffree( (yyvsp[-2].text) ); FECT;
                                            feperror( NULL );
                                        }
                                    ;}
    break;

  case 120:
#line 596 "ferite_parser.y"
    { 
                                        if( ferite_var_is_native )
                                          ferite_warning( ferite_current_compile->script, "Keyword 'native' can not be applied to variables ('%s' on line %d in %s)\n", (yyvsp[-2].text), ferite_scanner_lineno, ferite_scanner_file );
                                        if( ferite_last_type == F_VAR_STR )
                                        {
                                            FUD(("PARSER: Variable Declared         %s(%d)='%s'\n", (yyvsp[-2].text), ferite_last_type, (yyvsp[0].text))); 
                                            ferite_temp_variable = ferite_create_string_variable_from_ptr( NULL, (yyvsp[-2].text), (yyvsp[0].text), strlen((yyvsp[0].text)), FE_CHARSET_DEFAULT, FE_ALLOC );
                                            if( ferite_var_is_final )
                                              MARK_VARIABLE_AS_FINALSET( ferite_temp_variable );
                                            ferite_do_add_variable_with_value( (yyvsp[-2].text), ferite_temp_variable, ferite_var_is_global, ferite_var_is_static, ferite_var_is_atomic, ferite_item_state, FE_FALSE );
                                            ffree( (yyvsp[-2].text) ); ffree( (yyvsp[0].text) ); FECT;
                                        } 
                                        else 
                                        {
                                            ferite_error( ferite_current_compile->script, 0, "Can't initialise variable '%s' of type '%s' with the string '%s'.\n", (yyvsp[-2].text), ferite_variable_id_to_str( NULL,ferite_last_type), (yyvsp[0].text) );
                                            ffree( (yyvsp[-2].text) ); 
                                            ffree( (yyvsp[0].text) );
                                            FECT;
                                            feperror( NULL );
                                        }
                                    ;}
    break;

  case 125:
#line 630 "ferite_parser.y"
    { 
                                      if( ferite_class_state > 0 )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "The class already has state - you can't make it final\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_class_state = FE_ITEM_IS_FINAL; 
                                    ;}
    break;

  case 126:
#line 639 "ferite_parser.y"
    { 
                                      if( ferite_class_state > 0 )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "The class already has state - you can't make it abstract\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_class_state = FE_ITEM_IS_ABSTRACT; 
                                    ;}
    break;

  case 129:
#line 656 "ferite_parser.y"
    { 
                                      if( ferite_var_is_final )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already final - you can't make it final again\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_var_is_final = FE_TRUE; 
                                    ;}
    break;

  case 130:
#line 665 "ferite_parser.y"
    { 
                                      if( ferite_var_is_static )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already static - you can't make it static again\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_var_is_static = FE_TRUE;  
                                    ;}
    break;

  case 131:
#line 674 "ferite_parser.y"
    { 
                                      if( ferite_var_is_atomic )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already atomic - you can't make it atomic again\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_var_is_atomic = FE_TRUE;  
                                    ;}
    break;

  case 132:
#line 683 "ferite_parser.y"
    { 
                                      if( ferite_var_is_native )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already native - you can't make it native again\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_var_is_native = FE_TRUE; 
                                    ;}
    break;

  case 133:
#line 692 "ferite_parser.y"
    { 
                                      if( ferite_item_state > -1 )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already %s - you can't make it private\n", ferite_state_to_str( ferite_item_state ) );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_item_state = FE_ITEM_IS_PRIVATE; 
                                    ;}
    break;

  case 134:
#line 701 "ferite_parser.y"
    { 
                                      if( ferite_item_state > -1 )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already %s - you can't make it protected\n", ferite_state_to_str( ferite_item_state ) );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_item_state = FE_ITEM_IS_PROTECTED; 
                                    ;}
    break;

  case 135:
#line 710 "ferite_parser.y"
    { 
                                      if( ferite_item_state > -1 )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already %s - you can't make it public\n", ferite_state_to_str( ferite_item_state ) );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_item_state = FE_ITEM_IS_PUBLIC; 
                                    ;}
    break;

  case 144:
#line 742 "ferite_parser.y"
    { 
                                      if( ferite_var_is_final )
                                      {
                                          ferite_error( ferite_current_compile->script, 0, "Item is already final - you can't make it final again\n" );
                                          feperror( NULL );
                                      }
                                      else
                                        ferite_var_is_final = FE_TRUE; 
                                    ;}
    break;

  case 146:
#line 755 "ferite_parser.y"
    { ffree( (yyvsp[0].text) ); FECT; ;}
    break;

  case 147:
#line 756 "ferite_parser.y"
    { ffree( (yyvsp[0].text) ); FECT; ;}
    break;

  case 148:
#line 757 "ferite_parser.y"
    { ;}
    break;

  case 149:
#line 758 "ferite_parser.y"
    { ;}
    break;

  case 152:
#line 769 "ferite_parser.y"
    {
                                        FUD(("PARSER: Setting current type to %d\n", ferite_last_type ));
                                    ;}
    break;

  case 153:
#line 773 "ferite_parser.y"
    { ferite_var_is_final = FE_FALSE; ferite_var_is_static = FE_FALSE; ferite_var_is_atomic = FE_FALSE; ferite_var_is_native = FE_FALSE; ;}
    break;

  case 154:
#line 777 "ferite_parser.y"
    {
                                        FUD(("PARSER: Setting current type to %d\n", ferite_last_type ));
                                    ;}
    break;

  case 155:
#line 781 "ferite_parser.y"
    { ferite_var_is_final = FE_FALSE; ferite_var_is_static = FE_FALSE; ferite_var_is_atomic = FE_FALSE; ferite_var_is_native = FE_FALSE; ;}
    break;

  case 160:
#line 796 "ferite_parser.y"
    { ferite_do_begin_block(); ;}
    break;

  case 161:
#line 799 "ferite_parser.y"
    { ferite_do_end_block(); ;}
    break;

  case 171:
#line 827 "ferite_parser.y"
    { ferite_do_pop(); /* clear up the stupid stack ie wham = 2 + 3 leaves a variable on the stack*/ ;}
    break;

  case 175:
#line 831 "ferite_parser.y"
    { ferite_do_break(); ;}
    break;

  case 176:
#line 832 "ferite_parser.y"
    { ferite_do_continue(); ;}
    break;

  case 178:
#line 837 "ferite_parser.y"
    {  
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "compiled-in-return-value", FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(voidptr)        \n"));
                                        ferite_do_exit();
                                    ;}
    break;

  case 179:
#line 844 "ferite_parser.y"
    {  
                                        ferite_do_exit();
                                    ;}
    break;

  case 180:
#line 850 "ferite_parser.y"
    { ferite_do_if_statement(); ;}
    break;

  case 182:
#line 852 "ferite_parser.y"
    { ferite_do_iferr_block(); ;}
    break;

  case 183:
#line 853 "ferite_parser.y"
    { ferite_do_before_fix_block(); ;}
    break;

  case 186:
#line 859 "ferite_parser.y"
    { ferite_do_after_then_statement(); ;}
    break;

  case 187:
#line 860 "ferite_parser.y"
    { ferite_do_after_then_before_else_statement(); ;}
    break;

  case 188:
#line 861 "ferite_parser.y"
    {  ferite_do_after_else_statement(); ;}
    break;

  case 189:
#line 865 "ferite_parser.y"
    {
                                        ferite_do_pre_switch();  
                                    ;}
    break;

  case 190:
#line 871 "ferite_parser.y"
    {
                                        ferite_do_post_switch();
                                    ;}
    break;

  case 196:
#line 894 "ferite_parser.y"
    {
                                        ferite_do_case_block_start();
                                    ;}
    break;

  case 197:
#line 897 "ferite_parser.y"
    {
                                        ferite_do_case_block_end();
                                    ;}
    break;

  case 199:
#line 904 "ferite_parser.y"
    {
                                        ferite_do_default_block_start();
                                    ;}
    break;

  case 201:
#line 911 "ferite_parser.y"
    { ferite_do_after_fix_block(); ;}
    break;

  case 202:
#line 912 "ferite_parser.y"
    { ferite_do_after_fix_before_else_block(); ;}
    break;

  case 203:
#line 913 "ferite_parser.y"
    { ferite_do_after_fix_else_statement(); ;}
    break;

  case 204:
#line 917 "ferite_parser.y"
    {   
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "forconst", 1, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: for truth value\n")); 
                                    ;}
    break;

  case 206:
#line 927 "ferite_parser.y"
    { ferite_do_pop(); ;}
    break;

  case 208:
#line 932 "ferite_parser.y"
    {
                                        ferite_error( ferite_current_compile->script, 0, "'foreach' has been removed from ferite for more elegant methods.\n" );
                                        ferite_error( ferite_current_compile->script, 0, "Please console the documentation for the Array module.\n" );
                                        feperror( NULL );
                                    ;}
    break;

  case 209:
#line 940 "ferite_parser.y"
    {
	                                ferite_do_begin_block();
                                        FUD(("PARSER: [FOR] Begin Initial Expression\n"));
                                    ;}
    break;

  case 210:
#line 944 "ferite_parser.y"
    {  
                                        FUD(("PARSER: [FOR] End Initial Expression\n")); 
                                        ferite_do_for_loop_start();
                                    ;}
    break;

  case 211:
#line 948 "ferite_parser.y"
    { FUD(("PARSER: [FOR] Begin Test Expression\n")); ;}
    break;

  case 212:
#line 949 "ferite_parser.y"
    { FUD(("PARSER: [FOR] End Test Expression\n")); ;}
    break;

  case 213:
#line 950 "ferite_parser.y"
    {  
                                        FUD(("PARSER: [FOR] Begin Itterator Expression\n"));
                                        ferite_do_for_loop_itterate();
                                    ;}
    break;

  case 214:
#line 954 "ferite_parser.y"
    {  
                                        FUD(("PARSER: [FOR] End Itterator Expression\n"));
                                        ferite_do_pop();
                                        ferite_do_for_loop_block();
                                    ;}
    break;

  case 215:
#line 960 "ferite_parser.y"
    {  
                                        FUD(("PARSER: [FOR] Jump back to test expression\n")); 
                                        ferite_do_for_loop_end();
					ferite_do_end_block();
                                    ;}
    break;

  case 216:
#line 966 "ferite_parser.y"
    { ferite_do_while_begin(); ;}
    break;

  case 217:
#line 967 "ferite_parser.y"
    { ferite_do_while_after_expr(); ;}
    break;

  case 218:
#line 968 "ferite_parser.y"
    { ferite_do_while_end(); ;}
    break;

  case 219:
#line 969 "ferite_parser.y"
    { ferite_do_do_start(); ;}
    break;

  case 220:
#line 971 "ferite_parser.y"
    { ferite_do_do_end(); ;}
    break;

  case 225:
#line 983 "ferite_parser.y"
    {  
                                        ferite_temp_variable = ferite_create_string_variable_from_ptr( NULL, "strconst", (yyvsp[0].text), 0, FE_CHARSET_DEFAULT, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(str)        \"%s\"\n", (yyvsp[0].text)));
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 226:
#line 990 "ferite_parser.y"
    {
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "true", FE_TRUE, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(str)        \"true\"\n"));
                                    ;}
    break;

  case 227:
#line 996 "ferite_parser.y"
    {
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "false", FE_FALSE, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(str)        \"false\"\n"));
                                    ;}
    break;

  case 228:
#line 1002 "ferite_parser.y"
    {  
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "longconst", (yyvsp[0].inumber), FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(int)        %d\n", (yyvsp[0].inumber))); 
                                    ;}
    break;

  case 229:
#line 1008 "ferite_parser.y"
    {  
                                        ferite_temp_variable = ferite_create_number_double_variable( NULL, "doubleconst", (yyvsp[0].fnumber), FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(float)      %f\n", (yyvsp[0].fnumber))); 
                                    ;}
    break;

  case 230:
#line 1017 "ferite_parser.y"
    {  
                                        ferite_do_variable_push( (yyvsp[0].text) );
                                        FUD(("PARSER: push(cvar)       %s\n", (yyvsp[0].text))); 
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 231:
#line 1022 "ferite_parser.y"
    {   ferite_do_variable_push( "self" ); ;}
    break;

  case 232:
#line 1023 "ferite_parser.y"
    {   ferite_do_variable_push( "super" ); ;}
    break;

  case 233:
#line 1025 "ferite_parser.y"
    {  
                                        FUD(("PARSER: op->array_slice\n"));
                                        ferite_do_many_op( FERITE_OPCODE_array_slice,3);
                                    ;}
    break;

  case 234:
#line 1029 "ferite_parser.y"
    {
                                        FUD(("PARSER: op->array_slice\n"));
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "slice_first",0, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable ); 
                                    ;}
    break;

  case 235:
#line 1035 "ferite_parser.y"
    { ferite_do_many_op(FERITE_OPCODE_array_slice,3); ;}
    break;

  case 236:
#line 1036 "ferite_parser.y"
    {
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "sliceconst", FE_STATIC );
                                        MARK_VARIABLE_AS_PLACEHOLDER( ferite_temp_variable );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        ferite_do_many_op(FERITE_OPCODE_array_slice,3);
                                    ;}
    break;

  case 237:
#line 1043 "ferite_parser.y"
    {
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "slice_first",0, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "sliceconst", FE_STATIC );
                                        MARK_VARIABLE_AS_PLACEHOLDER( ferite_temp_variable );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        ferite_do_many_op(FERITE_OPCODE_array_slice,3);
                                    ;}
    break;

  case 238:
#line 1053 "ferite_parser.y"
    {
                                        FUD(("PARSER: op->array_index"));
                                        ferite_do_binary_op(FERITE_OPCODE_array_index);
                                    ;}
    break;

  case 239:
#line 1057 "ferite_parser.y"
    {   /* that dash cunning end of array index type thingy.... */
                                        /* it wasnt cunning enough because it broke with the introduction of negative indices ;) - ntropy*/
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "void-placeholder", FE_STATIC );
                                        MARK_VARIABLE_AS_PLACEHOLDER( ferite_temp_variable );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                        FUD(("PARSER: push(int)        %d\n", FE_ARRAY_ADD_AT_END )); 
                                        FUD(("PARSER: op->array_index\n"));
                                        ferite_do_binary_op( FERITE_OPCODE_array_index );
                                    ;}
    break;

  case 242:
#line 1069 "ferite_parser.y"
    { ferite_do_self_push(); ;}
    break;

  case 248:
#line 1084 "ferite_parser.y"
    {  
                                        ferite_do_variable_push( (yyvsp[0].text) );
                                        FUD(("PARSER: push(cvar)       %s\n", (yyvsp[0].text))); 
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 250:
#line 1093 "ferite_parser.y"
    {  
                                        ferite_do_variable_pushattr( (yyvsp[0].text) );
                                        FUD(("PARSER: push(object property)       %s\n", (yyvsp[0].text)));
                                        ffree( (yyvsp[0].text) ); FECT;
                                    ;}
    break;

  case 252:
#line 1104 "ferite_parser.y"
    {  
                                        int *value = ferite_stack_pop( ferite_argcount_stack );
                                        FUD(("PARSER: op->c_obj_func       %s\n", (yyvsp[-4].text) ));
                                        ferite_do_object_function_call( (yyvsp[-4].text), ferite_current_arg_count );
                                        ffree( (yyvsp[-4].text) ); FECT;
                                        if( value != NULL )
                                        {
                                            ferite_current_arg_count = *value;
                                            ffree( value );
                                        }
                                    ;}
    break;

  case 253:
#line 1118 "ferite_parser.y"
    { ferite_do_add_variable_to_paramlist( (yyvsp[0].text), F_VAR_VOID, FE_BY_VALUE ); ffree( (yyvsp[0].text) ); FECT; ;}
    break;

  case 258:
#line 1132 "ferite_parser.y"
    { ferite_do_closure_start(); ;}
    break;

  case 259:
#line 1133 "ferite_parser.y"
    { ferite_do_closure_end_of_args(); ;}
    break;

  case 260:
#line 1134 "ferite_parser.y"
    { ferite_do_closure_end(); ;}
    break;

  case 262:
#line 1142 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_add );
                                         FUD(("PARSER: op->add          pop,pop\n")); 
                                    ;}
    break;

  case 263:
#line 1146 "ferite_parser.y"
    {   
                                         ferite_do_binary_op( FERITE_OPCODE_minus );
                                         FUD(("PARSER: op->minus        pop,pop\n")); 
                                    ;}
    break;

  case 264:
#line 1150 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_mult );
                                         FUD(("PARSER: op->mult         pop,pop\n")); 
                                    ;}
    break;

  case 265:
#line 1154 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_divide );
                                         FUD(("PARSER: op->divide       pop,pop\n")); 
                                    ;}
    break;

  case 266:
#line 1158 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_modulus );
                                         FUD(("PARSER: op->modulus      pop,pop\n")); 
                                    ;}
    break;

  case 267:
#line 1162 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_equals );
                                         FUD(("PARSER: op->equals       pop,pop\n")); 
                                    ;}
    break;

  case 268:
#line 1167 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_less_than_equals );
                                         FUD(("PARSER: op->less_than_eq pop,pop\n")); 
                                    ;}
    break;

  case 269:
#line 1172 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_greater_than_equals );
                                         FUD(("PARSER: op->grtr_then_eq pop,pop\n")); 
                                    ;}
    break;

  case 270:
#line 1176 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_less_than );
                                         FUD(("PARSER: op->less_than    pop,pop\n")); 
                                    ;}
    break;

  case 271:
#line 1180 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_greater_than );
                                         FUD(("PARSER: op->grtr_then    pop,pop\n")); 
                                    ;}
    break;

  case 272:
#line 1184 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_notequals );
                                         FUD(("PARSER: op->not_equal    pop,pop\n")); 
                                    ;}
    break;

  case 273:
#line 1189 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_left_shift );
                                         FUD(("PARSER: op->left_shift    pop,pop\n")); 
                                    ;}
    break;

  case 274:
#line 1194 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_right_shift );
                                         FUD(("PARSER: op->right_shift    pop,pop\n")); 
                                    ;}
    break;

  case 275:
#line 1199 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_or );
                                         FUD(("PARSER: op->binary_or    pop,pop\n")); 
                                    ;}
    break;

  case 276:
#line 1204 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_and );
                                         FUD(("PARSER: op->binary_and   pop,pop\n")); 
                                    ;}
    break;

  case 277:
#line 1209 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_xor );
                                         FUD(("PARSER: op->binary_xor    pop,pop\n")); 
                                    ;}
    break;

  case 278:
#line 1213 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_assign );
                                         FUD(("PARSER: op->assign       pop,pop\n")); 
                                    ;}
    break;

  case 279:
#line 1217 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_add_assign );
                                         FUD(("PARSER: op->plus_assign  pop,pop\n")); 
                                    ;}
    break;

  case 280:
#line 1221 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_minus_assign );
                                         FUD(("PARSER: op->minus_assign pop,pop\n")); 
                                    ;}
    break;

  case 281:
#line 1225 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_mult_assign );
                                         FUD(("PARSER: op->mult_assign  pop,pop\n")); 
                                    ;}
    break;

  case 282:
#line 1229 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_divide_assign );
                                         FUD(("PARSER: op->divie_assign pop,pop\n")); 
                                    ;}
    break;

  case 283:
#line 1234 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_left_shift_assign );
                                         FUD(("PARSER: op->left_shift_assign pop,pop\n")); 
                                    ;}
    break;

  case 284:
#line 1239 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_right_shift_assign );
                                         FUD(("PARSER: op->right_shift_assign pop,pop\n")); 
                                    ;}
    break;

  case 285:
#line 1244 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_and_assign );
                                         FUD(("PARSER: op->binary_and__assign pop,pop\n")); 
                                    ;}
    break;

  case 286:
#line 1249 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_or_assign );
                                         FUD(("PARSER: op->binary_or_assign pop,pop\n")); 
                                    ;}
    break;

  case 287:
#line 1254 "ferite_parser.y"
    {  
                                         ferite_do_binary_op( FERITE_OPCODE_binary_xor_assign );
                                         FUD(("PARSER: op->binary_xor_assign pop,pop\n")); 
                                    ;}
    break;

  case 288:
#line 1259 "ferite_parser.y"
    {  
                                         int *value = ferite_stack_pop( ferite_argcount_stack );
                                         ferite_do_new_object( ferite_current_arg_count );
                                         if( value != NULL )
                                         {
                                             ferite_current_arg_count = *value;
                                             ffree( value );
                                         }
                                         FUD(("PARSER: new object\n" ));
                                    ;}
    break;

  case 289:
#line 1269 "ferite_parser.y"
    {  
                                         FUD(("PARSER: unary plus\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_positive_var );
                                    ;}
    break;

  case 290:
#line 1274 "ferite_parser.y"
    {  
                                         FUD(("PARSER: unary minus\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_negative_var );
                                    ;}
    break;

  case 291:
#line 1278 "ferite_parser.y"
    {  
                                         FUD(("PARSER: right increment\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_right_incr );
                                    ;}
    break;

  case 292:
#line 1282 "ferite_parser.y"
    {  
                                         FUD(("PARSER: left increment\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_left_incr );
                                    ;}
    break;

  case 293:
#line 1286 "ferite_parser.y"
    {  
                                         FUD(("PARSER: right decrement\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_right_decr );
                                    ;}
    break;

  case 294:
#line 1290 "ferite_parser.y"
    {  
                                         FUD(("PARSER: left decrement\n"));
                                         ferite_do_unary_op( FERITE_OPCODE_left_decr );
                                    ;}
    break;

  case 295:
#line 1294 "ferite_parser.y"
    {  
                                         ferite_do_unary_op( FERITE_OPCODE_not_op );
                                         FUD(("PARSER: op->not_op           pop\n" ));
                                    ;}
    break;

  case 296:
#line 1298 "ferite_parser.y"
    {  
                                         ferite_do_unary_op( FERITE_OPCODE_eval );
                                         FUD(("PARSER: op->eval\n"));
                                    ;}
    break;

  case 297:
#line 1302 "ferite_parser.y"
    {  
                                         ferite_do_unary_op( FERITE_OPCODE_include );
                                         FUD(("PARSER: op->include\n"));
                                    ;}
    break;

  case 298:
#line 1306 "ferite_parser.y"
    {
                                         ferite_temp_variable = ferite_create_string_variable_from_ptr( NULL, "strconst", ferite_variable_id_to_str( NULL,ferite_last_type), 0, FE_CHARSET_DEFAULT, FE_STATIC );
                                         MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                         ferite_do_push( ferite_temp_variable );
                                         ferite_do_binary_op( FERITE_OPCODE_isa );
                                         FUD(("PARSER: op->include\n"));   
                                    ;}
    break;

  case 299:
#line 1313 "ferite_parser.y"
    {
                                         ferite_do_binary_op( FERITE_OPCODE_instanceof );
                                         FUD(("PARSER: op->include\n"));   
                                    ;}
    break;

  case 300:
#line 1317 "ferite_parser.y"
    { ferite_do_get_args(); ;}
    break;

  case 301:
#line 1318 "ferite_parser.y"
    { ferite_do_get_yield_block(); ;}
    break;

  case 309:
#line 1329 "ferite_parser.y"
    { ferite_do_if_statement(); ;}
    break;

  case 310:
#line 1330 "ferite_parser.y"
    { ferite_do_after_then_before_else_statement(); ;}
    break;

  case 311:
#line 1331 "ferite_parser.y"
    { ferite_do_after_else_statement(); ;}
    break;

  case 313:
#line 1336 "ferite_parser.y"
    { ferite_do_yield_block( FE_FALSE ); ;}
    break;

  case 314:
#line 1337 "ferite_parser.y"
    { ferite_do_yield_block( FE_TRUE ); ;}
    break;

  case 315:
#line 1343 "ferite_parser.y"
    { 
                                        int *value = ferite_stack_pop( ferite_argcount_stack );
                                        FUD(("PARSER: op->c_func       %s\n", (yyvsp[-4].text) )); 
                                        ferite_do_function_call( (yyvsp[-4].text), ferite_current_arg_count );
                                        ffree( (yyvsp[-4].text) ); FECT;
                                        if( value != NULL )
                                        {
                                            ferite_current_arg_count = *value;
                                            ffree( value );
                                        }
                                    ;}
    break;

  case 316:
#line 1354 "ferite_parser.y"
    { ferite_do_super_push(); ;}
    break;

  case 317:
#line 1356 "ferite_parser.y"
    {
                                        int *value = ferite_stack_pop( ferite_argcount_stack );
                                        ferite_do_object_function_call( "constructor", ferite_current_arg_count );
                                        if( value != NULL )
                                        {
                                            ferite_current_arg_count = *value;
                                            ffree( value );
                                        }
                                    ;}
    break;

  case 318:
#line 1365 "ferite_parser.y"
    { ferite_do_self_push(); ;}
    break;

  case 319:
#line 1367 "ferite_parser.y"
    {
                                        int *value = ferite_stack_pop( ferite_argcount_stack );
                                        ferite_do_object_function_call( "constructor", ferite_current_arg_count );
                                        if( value != NULL )
                                        {
                                            ferite_current_arg_count = *value;
                                            ffree( value );
                                        }
                                    ;}
    break;

  case 320:
#line 1377 "ferite_parser.y"
    { 
                                        int *value = ferite_stack_pop( ferite_argcount_stack );
                                        FUD(("PARSER: op->yield\n")); 
                                        ferite_do_yield_call( ferite_current_arg_count );
                                        if( value != NULL )
                                        {
                                            ferite_current_arg_count = *value;
                                            ffree( value );
                                        }
			            ;}
    break;

  case 321:
#line 1390 "ferite_parser.y"
    { 
                                        int *value = fmalloc(sizeof(int));
                                        *value = ferite_current_arg_count;
                                        ferite_stack_push( ferite_argcount_stack, value );
                                        ferite_current_arg_count = 0;
                                    ;}
    break;

  case 322:
#line 1396 "ferite_parser.y"
    { 
                                        int *value = fmalloc(sizeof(int));
                                        *value = ferite_current_arg_count;
                                        ferite_stack_push( ferite_argcount_stack, value );
                                        ferite_current_arg_count = 0;
                                    ;}
    break;

  case 326:
#line 1411 "ferite_parser.y"
    { ferite_current_arg_count++ ;}
    break;

  case 328:
#line 1415 "ferite_parser.y"
    {
                                        char *buf = fmalloc(256);
                                        ferite_var_array_count++;
                                        snprintf( buf, 256, "!__array%d__", ferite_var_array_count );
                                        ferite_do_add_variable( buf, F_VAR_UARRAY, FE_FALSE, FE_FALSE, FE_FALSE, FE_FALSE, FE_ITEM_IS_PUBLIC, FE_FALSE );                                        
                                        ferite_stack_push( ferite_compiled_arrays_stack, buf );
                                        FUD(("PARSER: push             array_start\n"));
                                        
                                        ferite_do_variable_push( buf );
                                        ferite_do_unary_op( FERITE_OPCODE_array_clear );
                                        ferite_do_pop();
                                    ;}
    break;

  case 329:
#line 1427 "ferite_parser.y"
    {
                                        char *buf = ferite_stack_pop( ferite_compiled_arrays_stack );
                                        ferite_do_variable_push( buf );
                                        ffree( buf );
                                    ;}
    break;

  case 334:
#line 1446 "ferite_parser.y"
    {
                                        ferite_do_variable_push( ferite_stack_top( ferite_compiled_arrays_stack ) );
                                        ferite_do_swap_top();
                                        ferite_do_binary_op( FERITE_OPCODE_array_index );
                                        ferite_do_swap_top();
                                        ferite_do_binary_op( FERITE_OPCODE_assign );  
                                        ferite_do_pop();
                                    ;}
    break;

  case 335:
#line 1455 "ferite_parser.y"
    {  
                                        ferite_temp_variable = ferite_create_void_variable( NULL, "void-placeholder", FE_STATIC );
                                        MARK_VARIABLE_AS_PLACEHOLDER( ferite_temp_variable );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );
                                    ;}
    break;

  case 336:
#line 1461 "ferite_parser.y"
    {   ferite_do_swap_top(); ;}
    break;

  case 337:
#line 1465 "ferite_parser.y"
    { ferite_do_if_statement(); ;}
    break;

  case 338:
#line 1466 "ferite_parser.y"
    { 
                                        ferite_do_after_then_before_else_statement();
                                        /* we have to push a value onto the stack, otherwise we end up with a smashed stack */
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "true", FE_FALSE, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );                             
                                        ferite_do_after_else_statement();           
                                   ;}
    break;

  case 339:
#line 1474 "ferite_parser.y"
    { ferite_do_not_if_statement(); ;}
    break;

  case 340:
#line 1475 "ferite_parser.y"
    { 
                                        ferite_do_after_then_before_else_statement();
                                        /* we have to push a value onto the stack, otherwise we end up with a smashed stack */
                                        ferite_temp_variable = ferite_create_number_long_variable( NULL, "true", FE_TRUE, FE_STATIC );
                                        MARK_VARIABLE_AS_COMPILED( ferite_temp_variable );
                                        ferite_do_push( ferite_temp_variable );                             
                                        ferite_do_after_else_statement();           
                                   ;}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 3742 "ferite_parser.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1485 "ferite_parser.y"


int ferite_parse()
{  
   int parser_return = 0;
   
   FE_ENTER_FUNCTION;
   parser_return = fepparse();
   FE_LEAVE_FUNCTION( parser_return );
}


